Sat Jul 23 18:37:39 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS and set new version

Thu Jul 21 20:58:01 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * fix assertion that caused a crash, when removing the last shape (unplaced) shape from a solution (when lowering the max count)

Thu Jul 21 20:36:39 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * fix a nasty bug in expensive rotation analysis

Sun Jun  5 13:01:21 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * update some comments in movement analysator

Sat Apr 23 19:21:10 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * make burrTxt2 compilabe on windows, missing include file

Mon Apr 18 20:27:12 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * use boost threads for the thread class

Tue Apr 19 17:59:54 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * fix png saving, remove the deprecated PNG interface

Mon Apr 18 20:12:32 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * proper boost library configuration

Mon Apr 18 20:01:56 CEST 2011  Andreas Röver <roever@users.sourceforge.net>
  * change copyright to 2011

Sat Feb 12 17:47:16 CET 2011  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.6.1

Sat Feb 12 17:46:52 CET 2011  Andreas Röver <roever@users.sourceforge.net>
  * version 0.6.1

Sat Feb 12 13:02:12 CET 2011  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS file for next release

Sun Nov 28 15:27:31 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * simplify STL export file name generation

Thu Nov 25 21:04:15 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * when changing the shape in the STL exporter clear the hole list

Thu Nov 25 20:54:33 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix 2 memory leaks in the STL export window

Mon Nov 22 21:10:00 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * add a file chooser to the STL export window

Mon Nov 22 06:52:30 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * update copyright date in about window

Sun Nov 21 21:06:06 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix a problem that resulted in all error messages of the solver beeing asserts instead of meaninful messages

Tue Nov  2 18:51:00 CET 2010  smiteo@yahoo.com
  * stl hole crash fix

Sat Oct  9 13:33:01 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.6.0

Sat Sep  4 14:14:55 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * it is not BurrTool but BurrTools

Sat Sep  4 14:11:41 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix placement browser

Tue Aug 31 21:26:12 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * bigger resolution screenshots for user guide, but still downscaled for online helpt end web page

Mon Aug 30 20:42:52 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * improve wireframe mode for the new polyhedron code

Sat Aug 28 17:10:15 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * update comment regarding finding out if the internal void is valid

Sat Aug 28 17:10:01 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * version update to 0.6.0

Sat Aug 28 17:08:58 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * update documentation and NEWS filie

Sat Aug 28 14:15:28 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * better text in config window

Wed Aug 25 20:43:30 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * add proper includes for current gcc

Wed Aug 25 20:43:07 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * update documentation regardin STL export

Wed Aug 25 20:40:09 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * resort polygon STL export parameter, also implement bevel offset check, too big values are not detected

Mon Aug 23 21:59:30 CEST 2010  smiteo@yahoo.com
  * setting/clearing holes

Mon Aug 23 19:49:30 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * add generation of holes that connect inside and outside of stl exported shapes, patch by Derek Bosch with modifications by me

Sun Jul 25 16:07:10 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in the exception code

Sun Jul 25 16:01:01 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * prepare for holes in STL export

Sun Jul 11 11:57:44 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix usage of deprecated libpng interface

Sun Jul 11 11:25:01 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * make BurrTools compile with fltk-1.1 and fltk-1.3

Sun Jul 11 10:05:35 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * rename the Statusline pointer variable in mainwindow from "Status" to "StatusLine" to prevent problems with fltk-1.3

Sun Jul 11 09:46:06 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * remove some unused functions from FLU tree browser

Mon Jul  5 21:40:18 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * drawing optimisations

Mon Jul  5 21:11:31 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * enable silent compiling

Sat Jul  3 11:35:24 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * throw exception when writing to file is not possible

Sat Jul  3 11:30:46 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * make compilale under gcc-4.4

Sun Jun 27 12:40:50 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * remove tabs and a bit of formatting in Dereks code

Wed Jun 23 19:40:55 CEST 2010  smiteo@yahoo.com
  * STL comments and debug cleanup

Wed Jun 23 18:14:12 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * update the hole removal code

Sat Jun 19 17:12:46 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * don't throw object pointers, but objects when an exception happens

Sat Jun 19 16:19:19 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix deleting the last shape

Sun Jun 13 13:23:26 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * remove the last traces of the grid tpe parameters

Sun Jun  6 18:17:04 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * make some changes to places that often have merge conflicts... hopefully this will make things simpler

Sun Jun  6 17:27:01 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * make build process place object files within subdirectories

Sun Jun  6 16:46:40 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * missed 2 files with the new copyright header, also add a README file for the flu directory, finally add READMEs to dist

Sun Jun  6 12:13:48 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * unify, simplify and add copyright preamble
  
  - All files do now have the same copyright preamble
  - The text no longer contains the years, instead it references a document that contains the copyright years
  - add the preabmle to some files that were missing is altogether
  - add a comment to halfedge library readme

Sun Jun  6 11:22:55 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * add the new image to the distribution

Sun Jun  6 11:05:48 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * updates for void generation in STL output
  
  - STL export window can display the void so that is is possible to see, wheter it looks good or not
  - some shuffling around of the GUI elements in the STL export window
  - this should also fix a bug where the fade out of pieces on disassembly animation didn't work any more
  - make it possible to also remove the grooves on the inside void, making more volume saving posible

Sat Jun  5 21:59:11 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in arcball, comments

Sat Jun  5 21:48:26 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * implement hollow STL export

Sat Jun  5 20:49:50 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * rewrite OpenGL and STL output
  
  OpenGL and STL export now share common code using a general polyhedron library. This results in less code dublication. Beside that is also has some
  more consequences
  - The 3d drawing code is simplified as it is no longer needs to hand down the gridtye to create the proper drawer
  - The drawer is now a generalized polyhedron-drawer
  - STL export window has been updated, can support different types of parameters and properly previews the STL-object
  - The mesh generation is now part of the voxel class
  - the 3D cursor can be seen properly because the 3d object on screen can be offset as well
  - documentation updates

Sat Apr  3 13:39:26 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix a problem loading complex groups in the problem loader

Fri Apr  2 21:04:23 CEST 2010  Andreas Röver <roever@users.sourceforge.net>
  * new rotater method that can be used instead of arcball, also update the rotater in the process, using a base class

Sun Mar 21 14:51:41 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * remov unnesessary header

Sun Mar 21 14:51:04 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix a few old NEWS items

Sun Mar 21 13:58:27 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix a few warnings by adding some brackets and braces

Tue Mar 16 21:00:45 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix warnings in STL class regarind ignoring the return value of fwrite

Tue Mar 16 21:00:05 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * fixe some variable warnings

Tue Mar 16 20:58:54 CET 2010  Andreas Röver <roever@users.sourceforge.net>
  * fix some warnings in the flu file chooser coming from const char * stirng literals

Sat Oct 24 21:52:10 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * rename some more functions with regards to the new part name, also make piece counte setter update the solutions so that we can keep them
  
  when you now change a counter in the part list, the solution list is updated to relate that fact. Before that the solutions were all deleted.
  
  So it is now possible to remove shapes from problems without loosing the complete list, you can also delete shapes form puzzles

Sat Oct 24 21:44:41 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * introduce an unknown state for a problem, where only unstructured information is available

Sat Oct 24 16:24:09 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * implement grid scaler for rhombic grid
  
  this is not the final result, there are no outer faces and it doesn't work for all scaling factors, so more needs to be done

Thu Oct 22 17:58:04 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.5.2

Thu Oct 22 17:57:37 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * make release 0.5.2

Tue Oct 20 18:27:40 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * some documentation for 0.5.2 release

Thu Oct 15 17:43:11 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * start implementing grid scale functionality, which will help creating hollow meshes for STL export, right now cubes and triangles work

Thu Oct 15 17:28:58 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove some tabs that have crept in... I HATE tabs

Wed Oct 14 20:36:03 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a bug with the new 'variable voxels in shapes' mode

Wed Oct 14 20:35:33 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a bug in the rotation remove that let too many sphere solutions slip through

Wed Oct 14 20:35:08 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add some (inactive) debug code for the rotation removal code

Mon Oct 12 20:03:58 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove function from problem that was only used in one place

Mon Oct 12 19:01:30 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * move out the solution class used in problem into its own file and remove access functions to that information from problem
  
  This makes the problem a bit smaller and cleans up the interface a bit, more cleanup in that interface will follow

Sun Oct 11 16:29:07 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * rename problem_c.shapeIdRemoved to shapeRemoved and problem_c.shapeNumber to partNumber

Sun Oct 11 14:17:46 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * setResultId now removes solutions on its own
  
  this is a new way of doing it, the GUI no longer should worry about
  invalid solutions and such stuff, it can just change things in a puzzle or
  a problem and they will get updated accordingly...

Sun Oct 11 14:10:21 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * rename result functions to be clear about what they set and get

Sun Oct 11 13:39:38 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * let's start another round of proble_c interface renaming in the hope of a better interface
  
  the new interface will distinguish between pieces and parts. parts are the list in the problem,
  while pieces are the final shapes in the assembly, piece 0 belongs to part 0 which is of a certain shape

Sun Oct 11 13:18:21 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * use resultValid instead of resultInvalid, that is more intuitive and also used more often this way

Sun Oct  4 15:48:02 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * allow variable cubes for assembler and disassembler, they are treated like empty cubes

Wed Sep 23 21:20:36 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove xml libraries from the about window

Tue Sep 15 20:57:06 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * allow the STL export of hololow spheres

Sun Sep 13 18:25:15 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * some whitespace changes to movement browser (spaces at the end of lines)

Sun Jul  5 16:14:57 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * some bitfield tests

Sun Jul  5 16:14:43 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * some NEWS updates

Sun May 31 17:22:22 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * lay down basic structor for a unit test for the library

Sat May 30 10:59:30 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * initialize the hotspot after creating a voxel space out of an assemly
  
  this fixes a bug when importing sphere puzzles as spheres don't allow hotspots in all places and
  the default hotspot sometimes was wrong

Sat May 30 10:27:36 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove a warning and some spaces at the end of the lines

Wed May 27 21:55:27 CEST 2009  Barry Downes <barry.downes@gmail.com>
  * add "step back" button to movement browser
  add a "step back" button to select the parent of the current node
  also don't draw the coordinate system axes in the movement browser - they look ugly

Wed May 27 21:52:02 CEST 2009  Barry Downes <barry.downes@gmail.com>
  * implement push/pull feature for the movement browser
  This allows pushing/pulling of pieces by holding shift or ctrl and clicking on the pieces in the 3d view.
  Holding alt forces a move to be accepted even if it is illegal (because another piece is in the way).

Wed May 27 21:50:01 CEST 2009  Barry Downes <barry.downes@gmail.com>
  * add findMatching method to movement analysator

Tue May 26 23:13:57 CEST 2009  smiteo@yahoo.com
  * STL facet duplication
  Changed the rotation matricies used to generate the STL facets.  Some
  facets were being output twice during the make_edges routine.

Thu Apr 30 17:01:42 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix link in documentation

Thu Apr 30 16:50:37 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * use a weight for the prisgon box

Wed Apr 29 18:06:47 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.5.1

Wed Apr 29 17:43:39 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * preparation for 0.5.1 release

Wed Apr 29 17:37:03 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * explain the movement browser a bit

Wed Apr 29 17:33:33 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add all possible warnings

Mon Apr 27 21:42:05 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * deactivate the movement browser when nothing to browse is available or no disassembler is there

Mon Apr 27 21:15:46 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a rounding bug in the transform point routine for spheres, resulting in wrong assembly transformation and then missing solutions

Mon Apr 27 20:18:23 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a fix for the voxel table, sphere shapes don't have all transformations returned by the uniqueRotation function

Thu Apr 23 20:26:59 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix boundg box calculation after a translation

Sun Apr 19 12:01:09 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix uninitialized variable

Sat Apr 18 21:50:33 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a function to the thread class that allows to check, whether the thread is actually running

Sat Apr 18 16:51:58 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add 2 tools functions and start using the homedir function, the fileexists function will be put to use later on

Mon Apr 13 12:07:05 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * update gl2ps to vertion 1.3.3

Sun Apr 12 11:35:48 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * some more consts in the library

Sat Apr 11 20:02:23 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * a bit of const-ness in some functions of the library

Tue Apr  7 21:10:54 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix letter document generation

Tue Apr  7 17:51:56 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix proble with expensive rotation check removing too many solutions

Mon Apr  6 17:50:54 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * typo

Mon Apr  6 17:48:17 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add mission popup attribute

Sun Apr  5 12:54:37 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * slight rephrasing of 2 places in the preface of ther manual

Sun Apr  5 12:33:42 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * proper case spelling for the generated manuals

Sat Apr  4 21:56:34 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.5.0

Sat Apr  4 13:10:38 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a problem with the group editor editing the wrong cells resulting in strange behavior

Fri Apr  3 20:58:22 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * include the tools library in the doxygen documentation, also generate better graphs

Fri Apr  3 19:23:21 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add stubs for copy constructor and assignment operator
  
  and also add default constructors where they are now needed due to no longer
  automatically created constructors

Fri Apr  3 18:00:48 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * move the gzstream and xml code into the tools library
  
  They don't really belong into the burr library and some ar programs don't create
  empty libraries

Fri Apr  3 17:35:42 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * some little updates to NEWS file

Fri Apr  3 17:34:04 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * use the mutable keyword instead of my ugly const_cast stuff

Fri Apr  3 17:33:26 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a remark regarding the content of the Future Plans chapter in documentation

Fri Apr  3 17:33:04 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * explain what sorting solutions by piece means

Fri Apr  3 17:32:45 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add some remarks regarding the piece generator usage

Fri Apr  3 17:31:30 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * better usage of @B@ and @A@

Fri Apr  3 17:29:37 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a not regarding not always up to date screenshots

Thu Apr  2 18:32:45 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add the document name to the footer, so that one can find out to shich version of BurrTools excepts blong

Thu Apr  2 17:25:04 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the backups from the doc_src directory before the directory gets added to the distribution

Thu Apr  2 17:17:15 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix some typos in the README

Thu Apr  2 17:16:24 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a concrete example for the piece generation functions

Tue Mar 31 21:24:40 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * let the disassembler hash insert function return the found node (when found) instead of just ture and false

Sun Mar 29 18:41:13 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix some doxygen warnings

Sun Mar 29 13:55:14 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * explain the xmpuzzle format a bit

Sun Mar 29 11:55:27 CEST 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygen the xml stuff a bit

Sat Mar 28 18:14:39 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in disassembler classes
  
  create a common base for separation_c and separationInfo_c with virtual functions for functions that were available
  in both classes
  
  cleanup the problem interface accordingly, getDisassemblerInfo now returns the common base class
  
  the solver no longer needs to create a separationInfo class, when comparing solutions

Thu Mar 26 20:59:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * rename the exception thrown by the xml writer to obey my own coding styles

Mon Mar 23 20:37:58 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * finish doxygenisation of separation classes

Sun Mar 22 21:25:37 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * include the version number in the doxygen documentation

Sun Mar 22 20:34:29 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * next version will be 0.5.0

Sun Mar 22 20:33:15 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * use komascript for book layout, this saves us roughtly 20 pages due to more used paper surface

Sun Mar 22 20:32:39 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some improvements to comments for assemblers

Sun Mar 22 20:31:19 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add colons at the and of names list header entries to prevent right alignment of the last image

Sat Mar 21 21:54:38 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * document additional misc editing tools: fill holes

Sat Mar 21 21:28:06 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * tell the library documentation reader to read the manual for the GUI

Sat Mar 21 21:27:13 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * properly doxygenize the puzzle class

Sat Mar 21 17:25:57 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * update assmImport window, no crash when no problem is defined, remove unimplemented "count" button

Sat Mar 21 16:15:39 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * properly doxygenize the problem class

Sat Mar 21 13:18:23 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add doxygen header to some of the _number classes

Sat Mar 21 13:17:52 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize assembly stuff

Sat Mar 21 13:16:10 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove memory allocation and deletion on assembly construction for assembler_1

Sat Mar 21 12:35:05 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize further 3 voxel space classes

Fri Mar 20 17:53:17 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * the node data can differ, if the whole puzzle has shifted

Thu Mar 19 21:07:53 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize vixeltable and cleanup the interface

Wed Mar 18 19:19:14 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove some surplut newlines

Wed Mar 18 19:12:49 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add an integer division with rounding towards -inf and use it in all kinds of places

Wed Mar 18 19:02:24 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize disassembler classes, also add some updated documentation

Wed Mar 18 19:02:00 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize converter module

Wed Mar 18 19:00:51 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * make function static as it is only used inside the module

Wed Mar 18 18:59:55 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove 2 debug prints that crept in

Tue Mar 17 21:54:16 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup the reference counting stuff in the hash tables ab bit

Tue Mar 17 21:37:50 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * simplify constructor call a bit, comfreom needs to be not zero to work properly

Tue Mar 17 21:25:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * simplify piece position setting in disassemblerNode_c, the relative positions are always relative to comefrom node

Tue Mar 17 19:12:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * the replace node function doesn't need to copy all node information

Tue Mar 17 19:09:46 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a new function to create root disassemblerNodes

Tue Mar 17 18:12:05 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * use incRefCount and decRefCount instead of manual code

Tue Mar 17 18:11:15 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * there was one case left where I didn't use the new maxMove const to limit movement

Tue Mar 17 18:05:34 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * simplify the hashtable clearing a bit, no need to reparate the destructor case, it is used to rarely

Tue Mar 17 17:51:48 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize disassemblerNode_c and the disassembler hashtables

Mon Mar 16 17:07:37 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a problem with the disassembler node uncovered by the cleanup but living in there forever
  
  the transformation of the very first entry was not considered in the comparison and hash calculation
  
  additionally make sure that the hash valud is not zero as that value is used for unknown hash
  and finally make all movements larger than 10000 to removal movements, normally they are starting with 30000

Sun Mar 15 17:23:14 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove window installer stuff

Sun Mar 15 15:46:46 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * provide a means to define new hyphenation rules for TeX and properly hyphenate burr-tools

Sat Mar 14 22:33:50 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * document new voxel table features (speedup in status, filter in assembly import)

Sat Mar 14 22:33:00 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * implement dropping identical shapes as assembly import filter

Sat Mar 14 22:31:54 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some fixes to the voxel table (only use bounding box for hash calculation, noColour version disregards mirrored transformations)

Sat Mar 14 10:30:32 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * use the voxel table in status window calculations to speed things up considerably

Sat Mar 14 10:30:10 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a voxel table for fast lookup of same voxel spaces

Sat Mar 14 09:21:06 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add OR operator to bitfield

Fri Mar 13 18:31:55 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a new field to symmetry that will help generating all orientations of a shape, once the symmetry is known

Thu Mar 12 17:25:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix 2 problems in assembly import: uninitialized variables, and too little upper limit for default voxel count

Wed Mar 11 17:25:02 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * reformat NEWS file and also add some more points fr current version

Tue Mar 10 17:18:53 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some more text on  piece weights

Tue Mar 10 17:18:24 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some more remarks regarding colorisation

Tue Mar 10 17:17:29 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some more small fixes to documentation

Mon Mar  9 21:41:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * include images of tetra-octa grid for better visualisation

Mon Mar  9 21:38:31 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * generate letter and A4 documentation and include the BurrTool header in the title

Mon Mar  9 17:40:30 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add the mirror paradox demo

Mon Mar  9 17:31:45 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * revamp symmetry and rotation removal text

Mon Mar  9 17:28:33 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix typos, white space ad line ends

Sun Mar  8 21:31:54 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup of makefile to make sure the right files get added to distribution
  
  - move the source files dor th edocumentation in their own directory
  - the doc subdir now contains only the conversion script and the generated stuff that will not go int dist file
  - also correct generator scrips and dotygen.cfg, those should NOT go into the documentation

Sun Mar  8 15:19:46 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * shorten expensive rotation check checkbox text a bit and properly layout the 2nd row of action buttons of the solver

Sun Mar  8 14:08:05 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * new documentation, once more
  
  - a simple format plus a converter tool to convert it to html and tex. That text can then
    be formatted to an pfd using pdflatex
  - also some updates to the documentation for new features

Thu Mar  5 20:15:10 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * make sure created shapes from assembly are at least 1x1x1 in size as a zero sited voxel space is invalid

Thu Mar  5 20:15:03 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * implement min max voxel filter for assembly import

Thu Mar  5 19:30:49 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add missing GPL header

Thu Mar  5 18:16:15 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * proper initialize the commentPopup variable

Thu Mar  5 18:15:38 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * proper spelling for Markus' name (well at least on ISO ... -15 encoding)

Wed Mar  4 19:03:37 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * now we need to check for libz manually

Mon Mar  2 10:53:12 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix empty comment parsing

Mon Mar  2 10:21:52 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * rewrite XML loading and saving code
  
  - this removed the usage of xmlwrapp and libxml2
  - is much smaller in the statically linked case for windows
  - around twice as fast
  - requires a lot less memory, nearly nothing for saving and only buffers
    the size of the shapes for loading
  - I have everything in my hands now
  - get rid of my own load_error exception class

Mon Mar  2 10:15:31 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix memory leak in symmetry calculation for cubes, introduces when fixing the calculation for other rhombic and co

Sun Mar  1 20:41:13 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygen comments

Sun Mar  1 20:40:37 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * don't create latex doxygen files, we only want HTML

Sun Mar  1 20:40:23 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some updates to the README

Sun Mar  1 20:38:57 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add 2 missing header files

Wed Feb 25 16:57:59 CET 2009  Volker Grabsch <vog@notjusthosting.com>
  * bugfix: rebuild burrGui also when a source file of libburr changed

Wed Feb 25 16:13:47 CET 2009  Volker Grabsch <vog@notjusthosting.com>
  * workaround for Debian: include the autoconf-archive directory manually

Thu Feb 19 18:17:57 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some NEWS updates

Thu Feb 19 15:31:12 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some small improvements to status window
  
  - make the gray stripes span the whole lines (including checkbox and symmetry column)
  - include millable and notchable information for BRICK space grid

Wed Feb 18 17:43:14 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix status window remove shapes, now only the solutions of those problems are removed that contain the selected shapes

Wed Feb 18 17:28:26 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix use of uninitialized variable

Tue Feb 17 16:00:19 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix crash when opening a problem without result in the solver tab
  
  also check all other places where this problem might occure, add
  asserts in many places...

Tue Feb 17 15:40:25 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add millable and notchable checks for BRICKS grids for the assembly importer

Thu Feb 12 08:53:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * do only complain abount non placable pieces, when they actually need to be placed

Thu Feb 12 08:52:53 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a proper GUI for importing assemblie

Wed Feb 11 16:45:41 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * const-ness

Tue Feb 10 17:53:18 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * implement new rotation check
  
  this new rotation check is slower but it can also find translational solutions and
  rotational solutions not defined by the result shape

Tue Feb 10 17:52:41 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * split construction from transformation for the assembly, as now also the assembly might have impossible transformations

Tue Feb 10 17:46:20 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * getHotspot and getBoundingBox can now return false, when the requested orientation doesn't exist for the shape

Tue Feb 10 17:03:55 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * automatically regenerate when the auto-tool source files are changed

Mon Feb  9 21:54:42 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * all orientation and transformation types should be unsigned chars

Mon Feb  9 21:52:28 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * skip recalculation of the bounding box when doing conversion, this speeds up things quite a bit

Mon Feb  9 17:42:38 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add convertion from cubes to octa-tetra grid, and add a proper gui for target grid selection

Sun Feb  8 17:50:15 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in gridtype
  
  - add a NUM_GRIDS entry that is used wherever all grids are used
  - remove unused save case and simplify read switch in gridtype
  - fix warnings in some grid switches by adding a default case

Sun Feb  8 17:24:02 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the piecegenerator stuff, this is now done by the assembly import stuff

Sun Feb  8 17:19:57 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * rewrite gridtype conversion, and more 
  
  - instead of dong the conversion in-place we now create a new puzzle and replace
    it inside the GUI
  - get rid of the scary setGridType function in the puzzle
  - correcy a type in setComemntPopup
  - replace copying a problem from the puzzle by adding a problem with a pointer

Sat Jan 31 16:42:36 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * rename assemblerThread_c to solveThread_c as it does complete solving and not just assembling

Sat Feb  7 16:11:31 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * NEWS update

Sat Feb  7 16:09:18 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * the movement analysator now asserts the existence of a movement cache for the given problem

Sat Feb  7 16:08:35 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * the brrTxt tool would try to create a disassembler even when disassembly was not requested

Sat Feb  7 16:06:14 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a problem with the mirror filter
  
  When the 2 mirror pieces do have a different range assigned it can happen
  that after mirroring the now mirrored piece is outside of its valid range
  and thus the new assembly is invalid. The old code still used that assembly
  for the "is smaller" comparison trhowing away the valid base because of
  the new invalid assembly. It expected that this invalid assembly would be
  found but of course that is not the case. This resulted in missing solutions

Fri Feb  6 18:24:03 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add an example for the tetra-octa-grid

Thu Feb  5 18:20:24 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add Prisgon Example puzzle that uses the triangle disassembler

Thu Feb  5 18:13:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * switch disassembler node back to using 16 bit positions
  
  I've been a bit too optimistic with my hope that the pieces don't move more
  than 128 steps. Even simple puzzles can reach that number when they have a lot
  of movement freedom for single pieces. Then the whole structure can start to
  wander around.
  
  Well now we use 16 bit positions which should be enough. It is still only halve
  of the memory required in the old version

Wed Feb  4 20:45:49 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a simple disassembler for triangle grid

Wed Feb  4 20:28:22 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add new grid type: tetrahedonr octahedron based with assembler but no disassembler

Wed Feb  4 20:19:26 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize disasmtomoves and assembly

Wed Feb  4 20:18:14 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * piece number in disassembler node is an unsigned int

Wed Feb  4 20:16:24 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in disassembly
  
  - doxygenize
  - remove unused function
  - replace new-ed array and size variable with std::vector

Wed Feb  4 20:00:41 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in symmetries and doxygenize the base class a bit

Wed Feb  4 18:59:33 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * another missing header

Wed Feb  4 18:46:58 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix some warnings in library code

Wed Feb  4 18:45:49 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix some warnings in GUI code

Wed Feb  4 18:44:37 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add 2 missing header files

Sat Jan 31 22:17:11 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix edit color function in puzzle (I hate automatic type conversion)

Sat Jan 31 17:37:34 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS file

Sat Jan 31 15:31:57 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize grouping.h

Sat Jan 31 15:31:41 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * set compression level to highest for the zlib library

Sat Jan 31 15:31:15 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * reformat Makefiles
  
  Now all lines are equal no longer there are confligs when 2 pathces add files

Sat Jan 31 15:30:51 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * make sure no more than 63 colors are added (grey out button, add an assert)

Sat Jan 31 15:30:28 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * a slight optimisation for the cube grid movement calculation
  
  The loop below only starts working properly when the first voxel within sh1 is found
  so we only need to start scanning at the bounding box of sh1

Sat Jan 31 15:30:09 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add the doxigen configuration file to make dist

Sat Jan 31 15:29:50 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * reorganize movement cache 0 calculations a bit, this way it is faster and clearer what is going on

Sat Jan 31 15:28:53 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * assert cleanup
  
  All this came to the light when compiling without assert enabled
  
  - in some places we did something in an assert that also needs to be done when asserts are disabled
    as normal assert normally result in no code at all those actions were not performed. To solve that
    problem add an assert with side effect. So the operation within the assert is performed but no
    comparison is done and no exception thrown on problems
  - also fix a bunch of warnings because of unused variables without asserts

Sat Jan 31 15:28:12 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * reorganize the movement matrix in movement analysator so that we don't need to copy movement data twice
  
  instead of x matrices for all x directions we do now have one box matrix that contains the x values
  for the x directions one after the other. This required a lot of cot restructuring, but it should be
  a bit faster and cleaner

Sat Jan 31 15:27:49 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * switch move calculation return values to unsigned ints, they can only be positive or zero

Sat Jan 31 15:27:15 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in movement cache
  
  - reorganize the hash lookup function a bit
  - factor out the shape getting and calculation instead of having the same code 4 times
  - avoid recalculating the hash function when only the % tablesize changes

Sat Jan 31 15:26:51 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize gridtype and assembler a bit

Sat Jan 31 15:25:54 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the assembler frontends and fold that function into the voxel space class

Sat Jan 31 15:24:07 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup of movement cache interface for movement calculation
  
  This removes a few parameters, the array with the information with all
  directions is now alloctated in the calculation function because it knows
  how large it must be

Sat Jan 31 15:23:45 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * update documentation for voxel base class and also add a main page for the documentation

Sat Jan 31 15:23:28 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix 2 warnings

Sat Jan 31 15:23:13 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * update comments in puzzle.h

Sat Jan 31 15:22:59 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * check the grid type of voxel spaces added to a puzzle

Sat Jan 31 15:22:42 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove virtual keyword from inherited classes, it is not required

Sat Jan 31 15:22:16 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenization for disassembler base and voxel space

Sat Jan 31 15:22:00 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize movement cache and the STL base class

Sat Jan 31 15:21:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * a bit of cleanup in symmetry classes

Sat Jan 31 15:21:28 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * doxygenize the bitfield class

Sat Jan 31 15:21:15 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * sleep is not defined on windows, it's called Sleep there

Sat Jan 31 15:21:03 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * update the doxygen config file to only create docs for the library

Sat Jan 31 15:20:47 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * make the steps for the solution animation a bit smaller

Sat Jan 31 15:20:13 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix symmetry calculation for grid 0
  
  grid 0 symmetry calculations are also used by grid 3 (and maybe later even more) so we
  can no longer assume that voxel_0_c contains the right transformation functions, so we need
  to calculate those values dynamically

Sat Jan 31 15:19:12 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * update copyright for 2009

Sat Jan 31 15:18:47 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the table generation from normal build, this is just a nightmare for crosscompilation...

Sat Jan 31 15:17:42 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add another console application that actually saves results and can interrupt and continue solving

Sat Jan 31 15:16:52 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix cursor drawing one coordinate of one corner of one triangle was wrong

Sat Jan 31 15:16:29 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * simplify striped triangle drawing

Sat Jan 31 15:16:06 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the never needed prepare for assembly function

Sat Jan 31 15:15:06 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * re-organize movement cache in preparation for other movement information to be added later on (CM)
  
  - the debug information in movement cache is gone
  - the function that removes information converning one piece is gone, not used

Sat Jan 31 15:14:17 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add some missing includes (at least on some systems they are required)

Sat Jan 31 15:14:00 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * typo in variable names

Sat Jan 31 15:13:22 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * better solution sorting, much faster now

Sat Jan 31 15:12:54 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add simple method to add all assemblies as shapes to a problem

Sat Jan 31 15:12:37 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix warning

Sat Jan 31 15:12:18 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * the assembler must be deleted before the puzzle, or otherwise it might access already freed data

Sat Jan 31 15:11:45 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a script engine (lua) and add a first use for it: the configuration file

Sat Jan 31 15:10:40 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * properly use libraries for the sublibraries instead of linking the .a files

Sat Jan 31 15:10:19 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove a warning for uninitialized variable

Sat Jan 31 15:09:59 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * save restored assembler states, even if the assembler has not been restarted

Sat Jan 31 15:09:41 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the processor flags, they were used for assembler code which is no longer used

Sat Jan 31 15:09:14 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add some missing GPL headers

Sat Jan 31 15:08:51 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * update comment

Sat Jan 31 15:08:35 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * factor out voxel tretrahedra drawing stuff for other tetrahedral based voxel grids

Sat Jan 31 15:07:20 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in arcball

Sat Jan 31 15:06:42 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add some comments and remove unneeded class forward definitions

Sat Jan 31 15:05:48 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * comment the _number classes especially the space grid dependent classes

Sat Jan 31 15:05:19 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove some functions from the public interface of assembly, add a tiny bit of documentation

Sat Jan 31 15:04:30 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * replace the fixed size of the bounding box hotspot cache with the proper value depending on grid

Sat Jan 31 15:03:59 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove an unused function

Sat Jan 31 15:03:30 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * make sure to only use the result shape, when it is defined

Sat Jan 31 15:02:36 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix for color loading ... keep automatic conversation to boolean in mind when writing code

Sat Jan 31 15:01:39 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix adding the first piece to a problem

Sat Jan 31 15:00:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the outside member of voxel, is was always 0 (VX_EMPTY) any way and that value is now hardcoded

Sat Jan 31 15:00:19 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix typo

Sat Jan 31 14:59:51 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add more text to the hotspot

Sat Jan 31 14:59:19 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * there are puzzles that have no solution number field when solved, so don't expect it to be there

Sat Jan 31 14:57:44 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * show selected shape in problem view again
  **END OF DESCRIPTION***
  
  Place the long patch description above the ***END OF DESCRIPTION*** marker.
  The first line of this file will be the patch name.
  
  
  This patch contains the following changes:
  
  M ./src/gui/mainwindow.cpp -1 +1
  M ./src/gui/view3dgroup.cpp -4 +2
  M ./src/gui/view3dgroup.h -1 +1
  M ./src/gui/voxelframe.cpp -20 +20
  M ./src/gui/voxelframe.h -1 +1

Sat Jan 31 14:57:01 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * some cleanup in problem interface making things a bit easier to use (in some places)

Sat Jan 31 14:56:25 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * blocklist selection improvement
  
  the selection will now automatically select the first entry, when there is one and
  the seelction has been invalid before that

Sat Jan 31 14:55:53 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix for a problem introduces with the puzzle separation
  
  there might be more of that, now that we can no longer get the problem
  with an invalid problem index...

Sat Jan 31 14:55:03 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * assorted cleanup
  
  - remove the color structure and replace with an uint32_t that contains the 3 bytes
  - sprinkle some more asserts
  - remove some iterator usage, where not necessary
  - properly comment the puzzle class now that it is nice and tidy and small

Sat Jan 31 14:54:11 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * make small functions inline, remove some code that is pretty useless
  
  I will try to make all small functions inline, small means only one command
  or the assert plus one command
  
  remove the useless code used to convert old assemblies to the new format, this 
  should be done by now....

Sat Jan 31 14:51:24 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * separate puzzle from problem
  
  this is a first in a set of cleanup patches for the huge puzzle class
  it divides the puzzle in a puzzle class that handles a vector of
  problems. The problem was already used internally but never exposed
  
  Now the problem itself is used wherever possible instead of the puzzle
  problem index pair
  
  This is a huge patch with more than 800 changes, I hope I didnt mess up
  too much. I also didn't do the GUI update to nicely because there will be
  a new GUI anyway, so no need to be to fuzzy about that
  
  additionally the following things are done
  
  - remove the color constraint special class and replace the STL set template class
  - make some more functions inline
  - lots of comments in the header file
  - make the puzzle pointer a reference as there MUST be a puzzle
  - remove the insanity of 0xFFFFFFs for num Assemblies Solutions and usedTime, it now works with the solverState
  - the burrgrowing has been #if nulled, too much bit rot

Sat Jan 31 14:49:47 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add possibilities to print information about puzzles from burrTxt

Sat Jan 31 14:48:52 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * change the exception throwing into a function
  
  This makes is possible to have a breakpoint there for debugging and see where that exception
  came from. In the old code the exception was handled by the GUI and the debugger didn't get
  any note of it...
  
  The patch also fixes a bug in one assert condition

Sat Jan 31 14:48:12 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * factor out some more code in the disassemblers
  
  now only the graph analyzer is left within the disassembler making it nicely small

Sat Jan 31 14:47:07 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * more memory efficient disassembler node + get rid of that >10000 rubbish for removed nodes
  
  Now the disassembler can only work with puzzles up to 128 units in size because the positions
  of pieces can not be bigger, but the memory savings are probably more important, even the largest
  puzzles I know don't get that big
  
  the >10000 was used to show when pieces are removed. This didn't work any longer with such a small
  value range, so a better scheme (transformation + direction) is used. Thas big number scheme is
  still valid for the disassembly, so we need to work on that later on

Sat Jan 31 14:46:39 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * improvements to the movement browser
  
  - show colors and labels of pieces when do ing add movement
  - put a gap between the buttons
  - ...

Sat Jan 31 14:45:24 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * introduce 2 functions to calculate the shape and subshape from a given piecenumber

Sat Jan 31 14:44:38 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix problem with the new fixed positions class not knowing how many pieces there are

Sat Jan 31 14:43:26 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * even more cleanup in disassembler
  
  unsignify some variables

Sat Jan 31 14:39:56 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * plug some memory leaks found by valgrind mainly within the new movement browser

Sat Jan 31 14:38:24 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * further cleanup in disassembler classes
  
  - remove protected variables and make them public
  - remove some unused includes
  - reduce code duplication between the 2 disassembler_x classes a tiny bit
  - remove a lot of unnecessary function parameters, those values are class members...
  - join the 2 find routines that search for movements. They have been identical except for
    the coordinated motion cheks, they are now skipped, if disabled

Sat Jan 31 14:35:49 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * more disassembler cleanup
  
  - this greatly simplifies the weight usage. The weights are now within the movement analysator
    and nobody else needs to know about them....

Thu Jan 29 21:19:04 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * cleanup of disassembler classes
  
  this cleanup replaces the piecenumber + piece array pair with an stl-vector

Thu Jan 29 21:01:12 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a movement browser

Thu Jan 29 20:53:35 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * split of a movement analysator from the disassembler
  
  the analysator contains the functionality of alanysing what moves are
  possible, this is used by the disassembler but also by a coming movement
  browser that allows the user to find out what movements are possible in the
  assemblies

Thu Jan 29 20:28:07 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove limitation to 256 pieces for disassembler
  
  I don't know why I used voxel_type for the piece arrays that has never been right, at least
  not for a _very_ long time, anyway now it is removed resulting in some additional header file
  including cleanup

Thu Jan 29 20:13:53 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove no longer needed forward class definitions

Thu Jan 29 20:11:30 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add a fist, simple converter from cubes to rhombic grid

Thu Jan 29 19:47:36 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * further cleanup in disassembler code
  
  - move some more code to the common disassembler class

Thu Jan 29 19:38:19 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * another step in factoring out code from the disassembler in appreciation for multiple disassemblers
  
  This includes for now the code of Bill Cutlers movement checking methods and
  some utility functions for disassembler node creation
  
  more will follow

Thu Jan 29 19:33:26 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * switch over disassembler to same scheme as assembler
  
  as with assembler and assemblerFrontend we do now have disassembler and movementCache
  
  So the user can now select different disassembly engines and different gridy by
  choosing the right movement cache. The movement cache is selected by the griType_c class
  
  Right now there is only one disassembler, but later on we will get more, which can
  handle coordinated motion stuff

Thu Jan 29 18:52:23 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * a tiny bit of rearraning in the disassembler

Thu Jan 29 18:38:08 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * move the disassembler hash tables into separate file for later reuse

Thu Jan 29 18:28:18 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * remove the disassembler node class into its own class
  
  the node may be used by other disassemblers, also rename the node0_c to disassemblerNode_c

Thu Jan 29 18:15:09 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * start refactoring the disassembler
  
  The disassembler needs to be not so cube dependent. First step is to move out
  the number of possible directions and the direction vectors into the movement cache

Mon Jan 19 18:31:56 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add scrollwheel support for zooming in 3D view

Tue Jan 13 20:05:43 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.4.2

Tue Jan 13 20:05:16 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * actually add the icons file to the repository

Tue Jan 13 19:56:29 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * add an icon

Tue Jan 13 16:39:52 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * BallRoom does have 2 solutions for the first problem

Sun Jan 11 17:05:51 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * release preparations for 0.4.2

Sun Jan 11 16:52:39 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * prevent crash when setting z-layer and no shape is assigned

Sun Jan 11 16:45:55 CET 2009  Andreas Röver <roever@users.sourceforge.net>
  * fix a problem with rotation suppresion that could lead to too few solutions found
  
  When a symmetry breaker is found and the possible placements and rotations of that
  piece are calculated the rotations of that piece that can be round as symmetries
  in the result shape are ignored, too bad just that I also removed mirror placements
  when the box had mirror symmetries. This resulted in too many rotations of the symmetry
  breaker piece removed and thus in too few solutions
  

Sat May 10 12:06:56 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.4.1

Sat May 10 12:06:40 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * repare for 0.4.1 release

Mon May  5 21:47:03 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * do more precice 255 piece limitation check and add it at more places where it is required

Mon May  5 21:46:20 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * when the continue function does nothing we still need to update interface as we did something

Mon May  5 21:34:09 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * identical in BB for rhombic grid needs to look at the starting position of the box to make sure parity matches

Mon May  5 21:33:24 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * replace the use of "cubes" in the GUI with "voxels"

Fri Apr 25 18:22:13 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.4.0

Fri Apr 25 18:20:57 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add NEWS header and missing release dates

Thu Apr 24 17:33:09 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * mention the repeat mode when editing in 3D-view

Wed Apr 23 18:16:02 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove the burrTxt.exe from windows binary distribution, nobody will use it anyway

Tue Apr 22 20:13:07 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add some GPL header

Mon Apr 21 21:11:59 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * minimize "Ball Room" pieces

Mon Apr 21 20:43:49 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * long standing speeling mistake in Bills name

Sun Apr 20 18:10:13 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add documentation for the rhombic grid

Sun Apr 20 16:53:18 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * in resize to include for the rhombic grid we must make sure that the final size is multiple of 5

Fri Apr 18 08:48:47 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * make continuous firing less necessary whyn editing in 3D view
  
  Each time the mouse is moved another event is generated so slight mouse movements act like another
  click making it much more easy to "drill" holes

Sun Apr 13 13:26:17 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove unused rotation matrix from rhombic voxel class

Thu Apr 10 17:35:34 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add lee to the AUTHORS file

Tue Apr  8 20:23:46 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * update the about dialog a bit

Tue Apr  8 20:04:41 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add documentation for "keep rotations" feature

Sat Apr  5 10:36:08 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * fix flu file dialog problem with new FLTK release
  
  I hope that this works with the old AND the new FLTK. The fix also removes 2 debug printfs that
  were somehow left over for a long time already

Thu Apr  3 21:39:01 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * replace the left over openGL include #if construct with proper FLTK include

Thu Apr  3 20:30:17 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add edge matchin example

Thu Apr  3 19:49:42 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add chapter in documentation explaining limitations of sphere grid

Wed Apr  2 02:24:36 CEST 2008  smiteo@yahoo.com
  * mac os configure change to avoid unnecessary X11

Thu Apr  3 16:58:09 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * add a check for no more than 255 pieces per problem, more is not possible right now

Wed Apr  2 20:07:18 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * compiling data2c requires c++

Wed Apr  2 19:39:50 CEST 2008  Andreas Röver <roever@users.sourceforge.net>
  * revert some of the cleanup to the patches, no longer use pthread on windows... will be reverted later on

Wed Mar 26 21:09:43 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * fix problems with bounding box calculation, when some empty voxels still contained colors

Tue Mar 25 20:55:23 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * fix another problem with tirangle grid editor introduced by the grid editor cleanup

Fri Mar 21 14:31:59 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * change image for anaglyph mode to something more suitable, also add inverse anaglyph mode

Sun Mar 16 11:43:58 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * a bit of cleanup in assembler thread. More will follow in a later version of BT

Sat Mar 15 17:34:09 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add a thread class and use that class in assembler thread, cleanup of assembler thread will follow

Sat Mar 15 13:43:59 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add comment for half cubes regarding rhombic grid

Sat Mar 15 13:16:34 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add representation images for the rhombic grid space

Fri Mar 14 20:02:23 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * fix some unclosed html tags within the documentation

Fri Mar 14 20:01:45 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add missing documentation for the new example puzzles

Thu Mar 13 20:56:10 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove special treatment for windows regarding threads, use pthreads  library instead

Thu Mar 13 20:55:08 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove the pdf stuff from nsi installer script

Thu Mar 13 19:42:59 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * next version number is 0.4.0

Thu Mar 13 19:40:26 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add 7 stewart coffin puzzles as example

Sat Mar  8 10:04:10 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * fix problems in assembly print function. The function could not yet cope with not placed pieces

Sat Mar  8 10:04:00 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * implement the iteration counter for the assembler 1

Sat Mar  8 10:00:48 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add functions that check and print out the dancing link matrices

Sat Feb  9 12:27:18 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * apply the same optimisation to the voxel spaces 1 and 2

Sat Feb  9 08:58:09 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * optimize the transformation function for voxel_0 this is especially useful for the rhombic grid

Mon Feb  4 19:49:03 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * display list setting defaults to false, the more secure setting, readers of the doc do have the advantage

Sun Feb  3 18:38:35 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * document the new display list configuration option + remove a typo in STL description

Sun Feb  3 16:59:46 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add a configuration for display lists, as it seems they are not working with all openGL implementations

Sun Feb  3 09:41:08 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add documentation for the sphere STL export

Sun Feb  3 09:38:31 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * some updates to NEWS file

Sun Jan 27 17:31:40 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add documentation for vector image export

Sat Jan 19 20:22:11 CET 2008  smiteo@yahoo.com
  * fix basename routine for help files and mac-osx

Sat Jan 19 17:28:22 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove grid parameter menu entries and commented out code

Sat Jan 19 17:27:16 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add export to a vector image format

Sat Jan 19 15:05:06 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add a popup feature for the examples. Now the comment for the examples opens when they are loaded

Sat Jan 19 14:15:40 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add missing help viewer file

Thu Jan 17 18:08:15 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * implement saving the online help onto the disc, remove the close button

Sun Jan 13 22:09:02 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * improvements to html view
  
  - bigger initial font
  - a different character for the arrow
  - fixed size calculations for some fonts

Sun Jan 13 14:56:06 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * make F1 open the help

Sun Jan 13 14:55:30 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * lots of layout improvements for the html widget

Sun Jan 13 13:35:49 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * make cross compilabe on windows

Sun Jan 13 13:34:53 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add a small application to view the help externally for quick editing purposes

Sun Jan 13 11:17:16 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * scale large images down so that they can be easily viewed in the internal help

Sat Dec 15 15:32:09 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * first try at an included help system for burrTools
  
  This makes the documentation useless, so it is removed. The help will
  be compiled into the binary and for those that want a printed version
  I will make an exporting feature available

Sun Jan 13 13:31:48 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * literal strings are const char *

Sat Jan 12 15:09:01 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * introduce a piece contrast color function and us those new piece color functions wherever possible

Sat Jan 12 14:37:49 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * introduce direct fltk colors for piece colors

Wed Jan  9 20:16:40 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove warnings from Fl_Table

Wed Jan  9 19:09:45 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove the warnings in flu that come when compiling my own modules, flu internal warnings are still there

Sat Jan  5 18:37:01 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * check for overlapping spaces in the intersection voxel function, also disregard removed pieces

Sat Jan  5 12:46:53 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * also show acutal piece for prepare

Fri Jan  4 21:19:40 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * draw the coordinate system in positonOverlap display

Thu Jan  3 20:40:20 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add the overlap functions to the 3d group

Thu Jan  3 13:08:19 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * update copyright note

Thu Jan  3 12:48:50 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * in the new placement view function consider invisible pieces as not important

Thu Jan  3 10:30:08 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * remove unnecessary path in include
  
  this file has been in lib for a long time the path should have been removed then

Thu Jan  3 10:17:39 CET 2008  Andreas Röver <roever@users.sourceforge.net>
  * add functions to display free piece positionings with overlapping pieces

Sun Dec 30 16:51:01 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * rhombic grids are now always a multiple of 5 in size when created with the gui
  
  this will enable some other editing features later on when this is not the case things might go
  wrong with symmetric editing...

Sun Dec 30 15:04:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a special assembler frontend for rhombic grid
  
  - this is necessary because some shapes may be placed off of the 5 grid
  - it also increases speed

Sun Dec 30 14:21:49 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix for cursor drawing in grid editor
  
  - inRegion must only return true for valid voxel positions
  - the cube cursor drawer must paint all 4 edges because some
    of the surrounding cubes might be invalid and would not paint
    their edges

Sun Dec 23 13:42:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * reduce impact of big ranges of unplaced pieces on speed

Sun Dec 23 11:57:56 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make sure that the selected piece is visible when no shape has been added to the problem

Sun Dec 23 09:59:23 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * introduce hotsopt and bounding box cache
  
  Calculating the hotspot and the bounding box can be pretty expensive
  The cache introduced here will be used to reuse values calculated
  
  As this is even faster than the specialized version for cubes (when the
  cache is reused) the special versions are removed and the functions
  getHotsport and getBoundingBox are no longer virtual
  
  Right now the code assumes a maximum possible number of transformations
  instead of the proper value

Sat Dec 22 22:52:30 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix piece count incrementing in PS3D loader
  
  Because the piece range minimum has bot be smaller or equal to the maximum first incrementing
  the minimum and then the maximum resulted in 2 increments of the maximum when the first
  doublette of one piece was found resulting in ranges x-x+1 instead of x pieces

Sat Dec 22 17:52:50 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make it possible to deactivate the rotation check
  
  There are 2 reasony why this might be useful:
  - speed the check takes up quite some time
  - speed it might be that the "unrotated" solutions are found quite late and
    if you just want to know wheter there are solutions this might be enough for you

Sat Dec 22 17:37:23 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix warnings in burrTxt

Tue Dec 18 16:10:39 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * the 2 places that dis disassembly animation didn't use the same parameters resulting in desync

Sat Dec 15 13:53:43 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * string literals are const future versions of gcc will not compile when not so

Fri Dec 14 14:47:51 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix problem of piece moving out not moving along the motion vector

Tue Dec 11 11:37:31 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * speedup scaling function for rhombic disassember

Mon Dec 10 17:03:02 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix a warning and add more checks for stl_2 parameters

Sun Dec  9 13:14:36 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * base-class-ify the movement cache
  
  this is a preparation for future additional disassebly engines. The new movement cache interface
  will be usable by all of them

Thu Dec  6 03:13:01 CET 2007  smiteo@yahoo.com
  * stl fix for mac

Wed Oct 17 18:23:04 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  UNDO: add a space to the connect checkboxes to make clicking working properly

Wed Oct 17 18:23:04 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a space to the connect checkboxes to make clicking working properly

Wed Dec  5 18:37:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix some warnings

Wed Dec  5 18:23:37 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix merge conflict with sphere SLT export

Wed Dec  5 18:22:59 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a message "not implemented" for rhombic grid

Fri Nov 30 17:10:10 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * simplify the rhombic voxel class
  
  it now dereives from voxel_c_0 which already contains much of the required code for the
  transformations

Thu Nov 29 17:31:51 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a specialized tool tab for the rhombic grid

Thu Nov 29 17:24:32 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * rhombic grid editor now outlines selected area insted of framing all single cells
  
  this code also introduces edge neighbors because they are needed for the selection
  surrounding.
  Finally some code is added as commend that would print out the table that is
  used for the edge neighbors

Wed Nov 28 17:14:06 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a proper grid editor for the rhombic grid

Mon Nov 26 18:30:47 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * properly check for the right spacegrid in the tooltabs

Sun Nov 25 11:58:59 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement scaling for rhombic grid

Wed Nov 21 21:03:53 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * use the provided triangle drawing function

Wed Nov 21 20:00:23 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * first try at rhombic dodecahedra grid
  
  - voxel viewer is working, click editing is working, solving is working
  - grid editor is missing, scaling, ... some other features are also missing

Mon Dec  3 16:54:39 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * improvement and bugfix for color constrains marker position in grid editor for spheres

Sun Dec  2 21:55:49 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * simplification in sphere grid editor

Sat Dec  1 13:20:55 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove double ;

Sat Dec  1 12:33:55 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix in the placement browser setup function for a problem that was instroduced in the OpenGL cleanup

Sat Dec  1 12:03:18 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * update to the NEWS file

Sat Dec  1 11:42:20 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * use dynamic subdivision for angle finding instead of a fixed number of iterations

Sat Dec  1 11:32:52 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * better partitioning of the connection shape
  
  the line segment isnot made out of one section
  the curvature segment is specially fine graned

Sat Dec  1 11:25:24 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * use the same numbering scheme for the shapes as in the gui

Fri Nov 30 22:56:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add initial STL export for spheres
  
  This will require some improvements here and there for example speedwise,
  also the connections could use some adaptive tessellation to make sure they
  touch with the proper angle but it should work satisfactory in most cases

Fri Nov 30 17:09:39 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * only resize, when the new size is different

Fri Nov 30 17:09:08 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * only instanciate disassembler, when its actually used and only delete when there is one

Fri Nov 30 16:58:08 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * 2 more fixes for grideditor cleanup mistakes

Thu Nov 29 17:31:15 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * some little cleanup in tool tabl classes

Thu Nov 29 17:22:51 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix for a bug int the triangle grideditor introduced with the grideditor cleanup

Wed Nov 28 17:02:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in grid editor
  
  - the inverse of the inverse of the inverse y coordinate mess is removed, now the voxel
    is given to the drawing function and it has to handle everything else
  - in region for the cursor drawing has been simplified to only contain the
    parameters the drawing function knows about

Tue Nov 27 17:25:07 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix windows basename function
  
  - Windows doesn't have a basename function
  - also remove the now unneeded BINARY define

Sun Nov 25 13:50:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * better display of the stl export parameters

Sat Nov 24 19:11:22 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove some unused code

Sat Nov 24 19:09:36 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * get rid of error return codes and use exceptions instead, also a bit of formatting

Sat Nov 24 18:59:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove "test" code

Sat Nov 24 18:55:39 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper filenames for the STL export

Sat Nov 24 18:38:54 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * let the user select if he wants binary stl or not

Sat Nov 24 12:59:18 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in Dereks STL code
  
  - use a baseclass and derived classed for stl-exporter
  - use factory to get an STL exporter for current puzzle
  - fix normal vectors, they need to point outside
  - factor out the STL code: file open, write triangle, close
  - generic interface, gridtype now knows about is and the GUI will activate menu
  - generic interface for the window, the parameters are exporter specific

Sun Nov 25 11:59:37 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove unneeded header

Sat Nov 24 21:48:19 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix window placement restoration at startup

Fri Nov 23 17:59:15 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix for include header for windows

Wed Nov 21 20:59:14 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove commented out debug code

Wed Nov 21 20:06:18 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix a (not visible) bug in the placement of the grid parameter windows

Wed Nov 21 17:30:07 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * normal scaling is required after all

Wed Nov 21 17:06:23 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * dimming pieces did not activate openGL command list rebuild

Wed Nov 21 17:02:45 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * further cleanup of openGL code
  
  - make cursor working again
  - remove some more not needed includes
  - simplity the drawer and remove the darData function (fold into redraw)

Wed Nov 21 17:01:45 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * update copyright within the about dialog to 2007

Mon Nov 19 18:59:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement the usage of OpenGL Display lists

Sun Nov 18 21:55:26 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * continuing cleanup of voxel frame

Sun Nov 18 21:17:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fold some internal functions into code

Sun Nov 18 20:55:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * cleanup of voxel frame interface, get rid of unused functionality

Sun Nov 18 19:21:49 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove unused function

Sun Nov 18 19:10:46 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * separate voxel drawer and voxel frame into 2 files

Sun Nov 18 17:32:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a missing static

Sun Nov 18 17:29:37 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * get rid of the multiple gridTypeChanged functions in all voxel drawers, they do now have default implementation

Sun Nov 18 17:12:56 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * first step for voxelDrawer cleanup
  
  this patch spearates the drawer from the organisation part. We do now have the drawer
  which is different for each different space grid and only contains some drawing functions
  this part is exchanged when a new space grid is selected instead of the whole widget
  
  the 2nd part is the voxelFrame. This part organizes the shapes and calls the draw functions
  it has a drawer object that is calls for each grid dependend operation

Fri Oct 19 17:39:10 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove an unused function

Thu Oct 18 17:07:47 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * enable more warnings when compiling and remove most of them
  
  also remove the coordinate validation in the grid editor and use the new function provided by the voxel space

Wed Oct 17 19:56:30 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * enable grid filling for the other grids and a small fix for the filling function

Wed Oct 17 18:23:41 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a fill hole function
  
  - also add a function to validate coodinates, this is needed for the fill hole function
  - fill hole fills completely surrounded voids this is useful in more complex spaces where
    it is not obvious if a voxel is inside or outside in the grid editor

Wed Oct 17 17:15:17 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a feature to remove shapes using the status window

Fri Oct  5 19:18:26 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add some spaces to the connect check boxes so that they have a proper catchment area

Wed Sep 26 20:32:25 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * use best compression for UPX this reduces filesize to 80% of the old one

Sat Sep  8 15:57:21 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add the voxel space as parameter to the drawCursor function, is is used to find neigbours

Thu Aug 30 21:30:13 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove some unneeded headers

Thu Aug 30 17:55:13 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * prevent the object from rotating, when a modifier is pressed and editing is going on

Wed Aug 29 17:10:45 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the click-edit didn't honor the current color

Sat Jul 28 15:07:23 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.3.1

Sat Jul 28 15:02:46 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * some more printfs converted to print to stderr

Sat Jul 28 10:53:53 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix some warnings concerning signed, unsigned ints and always true comparisons

Fri Jul 27 18:19:16 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * version 0.3.1

Fri Jul 27 18:19:08 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * correct typo

Fri Jul 27 17:51:44 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * update 2 images

Fri Jul 27 17:51:05 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * only include the burrGui.exe

Wed Jul 25 20:24:18 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS file

Wed Jul 25 16:52:38 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * empty sphere grid can not be transformed, or it is the same as input

Tue Jul 24 21:36:23 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * printf cleanup
  
  remove unneeded ones and replace the other with prints to stderr

Tue Jul 24 20:37:49 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix some valgrind warnings (uninitialized variables)

Tue Jul 24 20:21:31 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * make a copy of the data required for solution viewing
  
  this is necessary because when the solver is running it might delete
  the currently visible solution and then moving the animation slider will
  crash the program. Now we have a private copy and nothing will go wrong

Tue Jul 24 20:21:04 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * free the assembler thread, when closing the window

Mon Jul 23 20:59:22 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * another symmetry for triangles

Mon Jul 23 18:05:01 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add documentation for 3d-interactivity

Mon Jul 23 17:01:16 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * replace neutral by default for the special color 0

Sun Jul 22 21:25:00 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * 2nd part of Joe Beckers editing on the userguide

Thu Jul 19 16:29:28 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix for separate builddir

Tue Jul 17 17:22:57 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * do a part of the userguide creation in the makefile

Mon Jul 16 17:18:38 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * improved build system by Volker
  
  - includes nsis script
  - some fixes to makefile about missing files
  - a bit cleanup

Mon Jul 16 17:06:46 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix a small typo in the examples readme

Mon Jul 16 17:05:38 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * some little improvements to bootstrap script

Sun Jul 15 14:10:12 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * use a define for the undefined transformation in the transformation multiplication matrix

Sun Jul 15 14:09:34 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add some compile flags (optimisation) to generator compilation

Sun Jul 15 13:48:43 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * better library checks

Sun Jul 15 10:59:37 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the generators for the table are now an in between result, no need to compile generator, when tables are there

Sun Jul 15 10:58:57 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * change library checks so that the config program can be given on the command line

Fri Jul 13 17:19:21 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * use cases instead of if for mingw check in configure

Wed Jul 11 19:20:27 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * after scaling the hotspot is gone

Mon Jul  9 18:22:20 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * do piece hiding in solution view only when shift is pressed

Wed Jul  4 20:46:17 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * prevent division by zero error when grid is much bigger than the grid editor
  
  the function that calculates the position within the grid can now return false
  which means that no coordinates can be calculated

Sun Jul  1 12:54:52 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * part 1 of Joe Beckers editing suggestions for the documentation

Sat Jun 30 09:12:10 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a check for the scandir type and whether the largefile variables are necessary

Thu Jun 28 16:39:56 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix a memory leak and an other problem with mirror detection

Mon Jun 25 20:26:16 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * better heurisitc for guessing with which column to continue in assembler 1
  
  this can result in quite some speedup (I've seen 3 times) but it still is just
  a heuristic and not mathematically founded. We do need something better in there

Mon Jun 25 17:02:52 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add function to sort solution by used pieces, also optimize solver button matrix a bit

Fri Jun 22 17:14:51 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix range optimisation
  
  the sometimes the no range pieces already take up more voxels than there are
  fixed voxels, so the minimum range might be negative, this is not possible so
  raise that value to 0

Fri Jun 22 13:42:26 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * better space utiliation in problem view, now measuring the size of the result independent from pieces

Fri Jun 22 11:14:07 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * optimize block list drawing to only draw visible blocks
  
  this speeds up drawing of lists with very many blocks that are mostly invisible

Fri Jun 22 10:41:08 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * change the new editor behavior
  
  now rotation is unchanged to the old sw
  - shift click adds a normal voxel
  - alt click adds a variable voxel
  - ctrl click removes a voxel
  
  the other views select or hide pieces by clicking at them

Fri Jun 22 09:50:11 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * solving and editing solution now also counts as changed and will result in asking to save when quitting

Sun Jun 17 21:23:20 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * openGL test only for non mingw32 systems

Sun Jun 17 11:03:59 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix hit searching, the last hit was not evaluated resulting in sometimes the wrong hit returned

Sun Jun 17 08:59:29 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * in problem 3d piece selection ignore shapes with number < 2 instead of asserting

Sat Jun 16 22:06:24 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * skip everything in the Select buffer that has not 3 name entries, necessary for the 3 axes

Sat Jun 16 21:52:01 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add shape selection via 3d in problem tab and piece hiding via 3d in solution tab

Sat Jun 16 21:32:46 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add left mouse click callback to 3d widgets and implement adding by clicking
  
  it is now possible to add voxels by clicking onto the faces of exising voxels
  normal left click adds normal voxel
  shift left click add variable voxel
  ctrl left click removes voxel below mouse

Sat Jun 16 21:31:07 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a function to voxel space to scale the space so that a given point can be included
  
  this point may be negative or everywhere else, the whole space is shifted so that
  the (now shifted too) point is within the available space

Sat Jun 16 19:32:13 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement face selection for triangles and spheres

Sat Jun 16 19:30:13 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * rotate only with 2nd mouse key

Sat Jun 16 13:20:36 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement shape picking in voxel drawer. it is now possible to find out what is below the mouse cursor

Sat Jun 16 13:12:41 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a function to get the x, y, z coodinates from the index into a voxel space

Thu Jun 14 19:42:52 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a check for openGL libraries and properly connect the strings for the pthreads

Thu Jun 14 16:45:40 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.3.0

Tue Jun 12 16:44:33 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * pthread c flags mut also be applied to linking

Mon Jun 11 16:55:01 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * don't search for posix threads on mingw, clarify error messages a bit in autoconf

Sat Jun  9 10:55:26 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * check for pthread and also exit configure with error, when libraries are missing

Fri Jun  8 17:05:24 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix the first, empty image that got drawn when making an assembly image sequence and mention image export improvements in NEWS

Thu Jun  7 21:27:58 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix comment from last comit

Thu Jun  7 16:30:04 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * make image export and display use the same perspective call

Wed Jun  6 21:33:20 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * Huge improvements to the image export layouting method
  
  - the final image size is better guessed by not adding a border when minimizing, but rather add a final image size
  dependend gap between the images
  - the layouter no longer works with a growing number of lines but with a decreasing hight of a row, this results in
  better utilisation of available space because a 1 pixel flater row might result in a fit, while the old method has to add
  a whole new row

Wed Jun  6 21:31:00 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * Use tiles when grabbing OpenGL images, this seems to be more stable (at least it works in my computer)

Tue Jun  5 20:10:41 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * use only the first solution, when enabling options in image export as other solutions can not be selected

Tue Jun  5 20:10:12 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * disable the image export menu entry, when there is nothing to export

Sun Jun  3 21:12:14 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the image export now updates the available output options when a new problem is selected
  
  this is necessary because different problems have different solving state

Sun Jun  3 18:23:53 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement assembly and disassembly image sequences for image export

Sat Jun  2 16:18:45 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * when in debug mode the program prints texts explaining what is going on

Sat Jun  2 16:18:17 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * calculate the number of columns and rows removed by the matrix optimisation

Sat Jun  2 16:11:23 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a counting optimisation
  
  the idea behind this is that if we have piece ranges and fixed pieces to place we do know
  how many voxels can be contributed by range pieces. An example, 10 piece with 6 cubes plus
  one 4 cube piece shall make a 4x4x4 cube. We want to try all different 4 cube pieces possible.
  This is done by adding all 4 cube pieces with a 0-1 range.
  Without the optimisation the programm will add several of the 4 cube pieces because there still
  are more than 10 placements for the 6-unit pieces.
  Now we add an additional column that contains the number of missing cubes as condition (in the
  example 4) and a weight for each of the range pieces that is equal to the number of units that
  piece is made of (again 4 in this example).
  The result is that the program will not add more range pieces than are possible due to the number
  of units the result has.

Fri Jun  1 17:58:40 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * set version to 0.3.0 for next release

Wed May 30 21:36:48 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * load system colors, also add a small space at the right for the OSX window resizer

Wed May 30 21:22:31 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * update documentation with piece ranges and the interface changes

Wed May 30 17:44:38 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * in problem detail editor the maxHoles input is only available, when there are piece ranges

Wed May 30 17:04:16 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * copy constructor for problem didn't copy the new maxHoles member

Wed May 30 17:01:13 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * missed to initialize maxHoles in problem when creating a new one

Wed May 30 17:00:36 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the problem detail editor is always available, even if no piece is in problem

Wed May 30 17:00:10 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * give the shape and problem selector a bigger minimum size

Wed May 30 16:59:45 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the problem detail editor needs a redraw after edit, because min and max might change one another

Wed May 30 16:59:12 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the last change to the 6-piece burr example saved only 100 solutions

Tue May 29 17:12:05 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix a gap in the color constrain editor visible on windows

Mon May 28 17:46:31 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add functionality to define the maximum number of holes alowed
  
  this is only usable in puzzles with piece ranges as in all other puzzles the number
  of holes (not occupied variable voxels) is fixed and calculatable

Mon May 28 15:14:54 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * groups editor is now also using the layouter

Mon May 28 13:00:55 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement hole optimisation for assembler 1
  
  this counts the number of holes alowed in an assembly and always checks if there
  are already more unfillable columns in the final assembly

Mon May 28 12:59:25 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * cleanup for debug interface and implement is for assembler 1

Sun May 27 21:22:58 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * some more cleanup in assembler 0

Sun May 27 19:31:54 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove some more stale code from assembler 0

Sat May 26 21:34:41 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * reformat the reduction function a bit

Sat May 26 21:33:58 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * show the right number of pieces in the main window when optimizing

Sat May 26 21:33:02 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix a pile of warnings

Sat May 26 19:45:26 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * sigh, bubble sorts works a bit different from what I implemented...

Sat May 26 17:59:09 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove everything concering multi-pieces from assembler 0

Sat May 26 14:59:17 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * optimize sort of assemblies a bit for piece ranges

Sat May 26 14:58:34 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * check at the start of the assembler, if we can actually solve the puzzle with this assembler

Sat May 26 14:09:36 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove debug code from assembler 1

Sat May 26 14:04:39 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement saving and restoring of state for the new assembler 1

Sat May 26 11:01:51 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fall through in the big switch in assembler 1 iterative function wherever possible to prevent unneeded looping

Sat May 26 11:01:27 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove the disassembly instructions from solid 6-piece file

Sat May 26 09:00:00 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * update the setup and 100% finished calculation to properly work

Wed May 23 21:15:15 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * update the NEWS file a bit

Wed May 23 21:00:14 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * groups editor is now the problem detail editor

Wed May 23 20:52:06 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix "-1" piece button, we need to first decrement min counter and then the max

Mon May 21 21:35:50 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * optimize assembly generation
  
  this little optimisation results in quite some speedup. e.g. solid 6 piece
  butt file went down to halve the time, others are even more interesting...

Mon May 21 21:20:06 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement iterative search function for assembler 1, the search is not interruptible but not savable

Sun May 20 17:59:11 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * simplyfy assembler 1 a tiny bit

Sun May 20 17:01:55 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the new assembler now properly reports the end of the calculations

Sun May 20 17:01:05 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * change the solide 6-piece burr example so that is it finished when loaded

Sun May 20 16:47:58 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement the fast row removal for the assembler 1 matrix
  
  now the new assembler should be fast enough to be really quicker for
  all multi piece puzzles...

Sun May 20 16:30:36 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * another twiddle with the time and solutions in the solver tab

Sun May 20 11:18:01 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * groupseditor now properly edits min and max piecenumber for all shapes

Sun May 20 11:17:05 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix problem in piece list on problem tab, sometime groups were not shown

Sat May 19 19:52:13 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * harmonize piece button labels, also correct the all+1 action, the min increase was missing

Sat May 19 19:25:44 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * shuffle elements in solver tab a bit around to make some more space

Sat May 19 18:24:14 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add an option for the assembler to keep mirror solutions
  
  this will be useful later on, when having a proper solutions browser
  when all mirror solutions are removed it might be possible that the number
  of solutions for a certain piece set changes, when other pieces appear
  or disappear because there suddenly exists a mirror solution with the other
  pieces and the first solution is removed

Fri May 18 18:24:55 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * when unmirroring pieces we also have to take unplaced pieces into acount
  
  unplaced pieces then do become places, and the original mirrored piece unplaced
  this allows to find mirror solutions that are made out of other pieces from the
  set of available pieces

Fri May 18 18:22:42 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * reduce now returns the piece it is working on in assembler 1

Thu May 17 20:12:16 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * theoretically is is possible to cover single rows multiple times, so don't assume next row here

Thu May 17 20:11:32 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * hide rows in assembler 1, once they are processed

Thu May 17 15:54:33 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * more cleanup, remove unneeded checks

Thu May 17 15:30:02 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in assembler 1
  
  factor out the row hiding into function now using only one vector for the hidden rows
  and not a stac variable. This will enable saving and loading further down. It also
  maked the recursive function smaller

Thu May 17 15:13:50 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * more cleanup in assembler 1

Thu May 17 14:38:57 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * some more cleanup in assembler 1

Thu May 17 13:37:45 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove a variable in assembler 1, preparations to remove recursiveness

Mon May 14 21:29:57 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * properly return the errorParam for errors instead of zero

Mon May 14 21:28:43 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * better coloring of multipieces. Now the colors are more similar for all colors

Sun May 13 15:10:42 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add an example for the piece ranges

Sun May 13 13:16:59 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * make reduce do loops until no more lines can be removed in assembler_1

Sun May 13 13:15:04 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix an infinite recursion problem in assembler_1

Sun May 13 13:11:04 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix piece list for problem: ranges and groups were not properly displayed together

Sat May 12 09:55:46 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * deactivate the assembly sections, they are way too hard to keep them working

Fri May 11 20:37:56 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * free memory for assembly when counting assemblies only

Tue May  8 11:35:51 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix mirror piece detection. This should fix the mirror removal problem

Tue May  8 11:26:38 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix uninitialized pointer in PieceVisibility widget

Tue May  8 11:25:54 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix another problem with the mirror code (see comment added in the code)

Mon May  7 20:02:46 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * empty assemblies are now created a different way, so remove that code

Mon May  7 17:50:38 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * make saving of non placements a bit more economic
  
  a non placement is now saved as a single "x" in the list

Mon May  7 17:50:07 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper min max check for assembler 1, to generate proper error messages

Mon May  7 17:49:32 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove unused parameter in assembler_1 prepare

Mon May  7 17:48:19 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a button to reset minimum to zero, also some more updates to interface for min-max

Mon May  7 17:44:23 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * if a piece is not used in the solution the piece visibility list will not display its name
  
  this is intended to make it easier to see, wheter a piece is used in the acutally selected
  solution

Sun May  6 21:37:28 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * replace shape count by a range
  
  this will make it possible to search for solutions containing a piece or not. E.g. it
  is now possible to search the 6 piece burrs (for example all solid ones, ...)
  
  Editing is not yet properly supported in the GUI, right now it is just displayed

Sun May  6 18:27:59 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * make BurrTools handle unplaced pieces
  
  this has always been prepared but never used and so it never properly worked. A piece
  is placed if its transformation is not 0xFF. This is now properly wrapped and checked
  in all placed where necessary (at least I hope so). 
  
  The patch also increases the possible number of pieces from 255 to MAXINT. This limit
  was caused by using an unsigned char as index into the placement...

Sun Apr 22 15:46:00 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * unite both recoursive functions as a first step to make is iterative

Sun Apr 22 13:20:18 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add placement browser for assembler_1

Sun Apr 22 12:59:11 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * make piece placement get functions virtual and available for all assemblers
  
  this new interface is obligatory, if the new assembler can not support is, it's ok

Sun Apr 22 12:36:17 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * wrong header included in assembler frontent 2

Sun Apr 22 12:24:40 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * calculation of getFinished is now better and doesn't jump around any more

Sat Apr 21 17:14:00 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add the new dancing link assembler
  
  this assembler is __WAY__ faster then the old one if it comes to multipieces
  it is a bis slower when only single pieces are involved. That is why the old
  one will live on. The old assembler will be simplified to only handle single
  pieces once the new assembler is working properly.
  
  So what works: it can assemble.
  
  Placement browser is not working, the reduction is not yet up to paar with the
  old assembler (the fast line removal is missing)
  
  The assembler is seleced in a factory function in the gridType_c class. In case
  it is neccessary to remove it just remove the selection of the new
  assembler in this class and make the canHandle function of the old assembler
  return always true
  
  Right now there are also quite some commented out debug prints left. They will vanish
  over time...

Sat Apr 21 17:11:09 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove some lines containing only spaces

Sat Apr 21 08:46:58 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.2.3

Fri Apr 20 20:01:04 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * prepare for version 0.2.3

Fri Apr 20 18:23:36 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * update Pelikan and Bermuda
  
  Pelikan had a slight error in the design
  Bermuda still had both mirror solutions

Fri Apr 20 18:11:00 CEST 2007  smiteo@yahoo.com
  * add provision to analyze all puzzles from command line

Fri Apr 20 17:07:53 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove x86_64 from assembler supported CPUs

Fri Apr 20 16:53:22 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * use asserts in the mirror code instead of if, they _have_ to be there

Fri Apr 20 16:51:07 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix another problem in mirror pieces
  
  this problem didn't occure because in all my puzzles the 2 mirror pairs are simply
  mirrored along the x axis resulting in t and t_inv equal to 24...

Sun Apr 15 14:03:37 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.2.2

Sun Apr 15 14:01:25 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * prepare release 0.2.2

Sun Apr 15 13:56:25 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * properly implement stopping after preparation phase and reenable prepare button

Sun Apr 15 13:43:29 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * disassembler will not even start for one piece problems

Sun Apr 15 13:42:57 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * correct some printf to use the right format parameter for the given values

Sat Apr 14 19:04:40 CEST 2007  smiteo@yahoo.com
  * fixing ebx clobber

Sat Apr 14 18:52:31 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add TARGET_CPU_x86_64 as supported CPU (for the available assembly code)

Sat Apr 14 09:33:03 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix the preprocessor CPU detection stuff

Fri Apr 13 17:13:19 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * add some comments to the mirror piece swapping code

Fri Apr 13 17:11:52 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper check for target CPU in assembly portions (also remove no longer used FLU define)

Thu Apr 12 17:39:19 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * make the "Prepare" and "Step" buttons invisible, they are only used by me anway

Thu Apr 12 17:30:41 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * Fix the new last mirror fix (sigh)

Thu Apr  5 21:40:51 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix 2 problems in mirroring of assemblies
  
  - one problem was that non minimized pieces didn't work properly (they jumped around)
  - the other problem was that the wrong shape was calculated to do the hotspot and
    bounding box calculations with resulting in wrong new coordinates
  
  all this resulted in not properly working mirroring of assemblies and thus in not
  working mirror solution suppression (or only sometimes working)

Sat Mar 31 14:25:06 CEST 2007  Andreas Röver <roever@users.sourceforge.net>
  * the prepare button is now active at the same time as the start button

Thu Mar 22 18:09:48 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * when starting a new puzzle, clear out the name of the old one from the title

Thu Mar 22 17:03:21 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.2.1

Sun Mar 18 12:38:48 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * Add images of anaglyph mode

Sun Mar 18 12:38:36 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add cairo emulation to documentation

Sun Mar 18 12:19:10 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove 2 unused images and update the others to look like the current GUI

Sat Mar 17 18:32:56 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * update news set version to 0.2.1

Sat Mar 17 18:31:32 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make mirror check initialisation handle identical pieces
  
  if there were 2 identical pieces in the problem (not multipieces but 2 identical ones)
  the initialisation of the mirror check structure went wrong. Now it works

Sat Mar 17 13:11:07 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * we may need to check for mirrors even when all rotations can be excluded
  
  the assembler didn't check for mirrored solutions when it tas shure that
  all possible rotations can be exluded. But mirrors are independend of
  rotations. So separate these 2 from one another

Sun Mar 11 17:33:01 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * properly set bounding box for empty shapes to all zero values
  
  this solves an assert, when problems contain empty shapes. THe bounding box was
  set too large and the compare in BB function tried to read the valued within
  that large BB and so tried to read invalid values

Fri Mar  9 21:21:25 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in documentation (remov empty environments, and double emphsasis)

Fri Mar  9 21:20:55 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * update image for emulation 45 degree cut cubes

Wed Mar  7 21:31:11 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add default colour rules when adding colours or when adding problems

Sun Mar  4 20:02:03 CET 2007  smiteo@yahoo.com
  * FLU changes for 64-bit compile errors

Sun Mar  4 18:01:48 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * layouted windows are not put into the center of the screen

Sun Mar  4 17:51:50 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make status window progress modal and add caption, also explain about it in manual

Sun Mar  4 16:16:06 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * update build system
  
  - include documentation and example when installing
  - exclude the headers when installing
  - bootstrap script gives parameters to configure call
  - docygen directory changed for better tab expansion

Sun Mar  4 14:05:04 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add tool tips for the 3 3-D modes

Sun Mar  4 13:49:22 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * updated to main window (anaglyph mode) and status window

Sun Mar  4 13:48:22 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove references to FLU from linux installation notes

Sun Mar  4 13:23:13 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a progress window when creating the status window as the creation might take some time

Sun Mar  4 13:21:16 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * a special begin method for the layouted window, to begin adding widgets to the window
  
  this is necessary because the layouted windows required you to add the widgets to the
  layouter inside the window, otherwise you will get problems. This of course only works
  when you have the right kind of pointer as the begin method is _NOT_ virtual

Sat Mar  3 18:51:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * change to version 0.2.1pre

Sat Mar  3 18:23:34 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * another 16 sphere symmetry groups

Sat Mar  3 17:32:00 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix problem with sphere not having all possible concatenations of 2 transformations
  
  is is solved by taking the transformation apart into 2 transformations and applying
  them separated instead of using the matrix multiplication which might result in not
  allowed values

Sat Mar  3 17:08:03 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * solve problem with transform point giving non integer results
  
  this is only possible with spheres and their crazy rotation problems...
  there is no possibility to assert that the assumption is right, so we must
  hope that it is

Sat Mar  3 11:54:15 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * 4 new symmetry groups for spheres

Sat Mar  3 11:22:51 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make the gray in red-blue mode a bit lighter so that dark shapes are visible as well

Fri Mar  2 18:25:58 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add the part of FLU that burrgui uses to the source
  
  I did this because FLU is not really a widely used library and some big dirstros like debian or
  gentoo don't contain it. When this library is no longer required chances rise that BurrTools
  get included there, making installation for Unix users simpler, so let's cross fingers

Fri Mar  2 17:39:19 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * missed one case where the Fltk include was wrong

Fri Mar  2 16:51:46 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper comments for the grid editor classes

Fri Mar  2 15:35:34 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * better centering for shapes in editor, problem and placement browser

Thu Mar  1 17:21:42 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * as the result shape gets shifted by the hotspot, we also need to correct the piece position

Mon Feb 26 20:31:50 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * status window needs to be modal, too (just like the other windows)

Sun Feb 25 13:28:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * split of assembler frontends from assembler class
  
  the frontends are no longer derived from assembler but a class tree
  of their own. This way we can have more than one assembler and all
  use the samel frontend

Sat Feb 24 16:49:58 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * View3dGroup is only used in its layoutable form, so remove the other case

Sat Feb 24 16:39:44 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make configuration use the layouter

Sat Feb 24 09:50:29 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * placement browser now uses layouter

Fri Feb 23 18:35:14 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove unneeded defines in the mainwindow that were left over from hand layouted times

Fri Feb 23 18:27:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * some cleanup with the left over of window widgets header file

Fri Feb 23 18:21:30 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * image export and stl export header weren't properly protected by header #ifs

Fri Feb 23 18:20:20 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move block list group into its file

Fri Feb 23 18:07:36 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move constraints group into its file

Fri Feb 23 17:58:46 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move button group into its file

Fri Feb 23 17:50:21 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move spearator into its file

Fri Feb 23 17:39:13 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move result viewer to its own file

Thu Feb 22 19:27:55 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move status line into its own file

Thu Feb 22 19:18:19 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove includes that are no longer required in window widgets file

Thu Feb 22 18:44:54 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move view 3d group into its own file

Thu Feb 22 18:20:26 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move voxel edit group into its own file

Thu Feb 22 18:07:34 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move toggle button into its own file

Thu Feb 22 17:54:33 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move assertWindow class out of WindowWidget file

Thu Feb 22 17:46:10 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move progressbar over to the layouter as it is only a layouted standard fltk widget

Thu Feb 22 17:35:26 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * split multiFileWindow class out of the WindowWidget class collection

Thu Feb 22 17:16:21 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * correct text for AlPachino puzzle

Wed Feb 21 20:53:07 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * 3 new cube and 45 new sphere symmetries, 2 triangle symmetries removed
  
  the 2 removed triangle symmetries are probably due to a software bug
  in the beginning, I can not find an example for those symmetry groups...

Wed Feb 21 18:06:39 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove unlayouted ToggleButton

Wed Feb 21 18:03:53 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove unlayouted BlockListGroup

Wed Feb 21 17:53:59 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove unlayouted Constraints Group

Wed Feb 21 17:43:01 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove no longer used Separator widget (the unlayoutable one)

Wed Feb 21 17:34:50 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove all calls to set the box to THIN_BOX and rather setup the normal box as thin at startup
  
  This saves as a lot of calls to the box function and it is more flexible

Sun Feb 18 14:23:53 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * correct 2 typos in comments

Fri Feb 16 17:28:47 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * rename function "symmetryCalcuation" (yes the name had a typo) to "calculateSymmetry"

Thu Feb 15 17:18:11 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * use proper count function for cost in stl export

Thu Feb 15 16:40:49 CET 2007  smiteo@yahoo.com
  * change STL file naming rules
  this patch changes the way STL names are generated to both reflect the material cost function (# of cm^3) as well as any given shape label

Thu Feb 15 16:39:44 CET 2007  smiteo@yahoo.com
  * change STL default parameters

Wed Feb 14 16:55:14 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a 3d anaglyph mode (red green glasses)

Tue Feb 13 16:37:18 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * replace texts in triangle nudge buttons with arrows

Mon Feb 12 21:30:54 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * status window symmetry column now shows the symmetry index, when known or "---" when not

Mon Feb 12 21:19:45 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove the debug symmetry checks
  
  this took up a lot of time for shperes, the check now is simpler
  and only tests for the actual shape. It used to check for all possible
  rotations whether the symmetrymask is known, that made 240*240 = 57600
  transform calls each time the symmete calculation was called for the sphere
  it also saved quite some time for the other spaces, but only on startup
  puzzles that take long still take long

Mon Feb 12 20:40:13 CET 2007  smiteo@yahoo.com
  * make default cubies display bigger (adjusting viewing frustum)

Sat Feb 10 17:32:21 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * correct encoding for tool tabs file to properly show the degree sign

Sat Feb 10 16:37:26 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.2.0

Sat Feb 10 12:09:29 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper enabling and disabling of the buttons in the solver tab button array

Sat Feb 10 00:56:48 CET 2007  smiteo@yahoo.com
  * fix GL clipping issue on BIG puzzles

Sat Feb 10 09:09:03 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * update copyright information and add missing headers

Fri Feb  9 22:01:09 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * release preparations for release 0.2.0

Fri Feb  9 16:50:01 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add check to the add assembly button routines and also disable the buttons and checkbox when not applicable

Thu Feb  8 18:00:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * another update to the 2 new puzzles

Thu Feb  8 17:58:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * also use my own rounding in the spheres voxel space transformations
  
  this is probably not really necessary because the crosscompiler on my
  mashine doesn't have the problem with rounding, but better be careful

Thu Feb  8 17:52:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * don't load puzzles with unknown grid type

Thu Feb  8 17:52:15 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * the speres do have an assembler, show that text

Thu Feb  8 17:51:44 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * sort buttons are disabled when there is nothing to sort, also add safety check

Wed Feb  7 21:39:09 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix some warnings

Wed Feb  7 18:19:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * colorize the label of the "identical" columns in the status window so that they stay readable

Wed Feb  7 18:18:58 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a proper value of the scrollbar size in the layoutable scroller

Wed Feb  7 18:04:19 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * the windows gcc seems to have a problem with rounding, so lets do it ourself

Tue Feb  6 21:33:24 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * many new symmetry groups (3 for cubes, 8 for triangles 39 for spheres)

Tue Feb  6 20:13:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * the table in status window is now inside a scroller to be able to see many shapes

Tue Feb  6 19:15:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a layoutable scroll area

Tue Feb  6 06:37:22 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove converter and tester these 2 programs are quite useless except for me

Mon Feb  5 19:40:07 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * another symmetry group for spheres

Mon Feb  5 19:38:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * replace big images with floats in documentation

Mon Feb  5 18:01:43 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * mention unificator in todo list

Mon Feb  5 17:16:31 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove an assert in triangle transform function that was left from spheres

Mon Feb  5 04:22:30 CET 2007  smiteo@yahoo.com
  * add cost function for volume of shape in stl export

Mon Feb  5 04:21:42 CET 2007  smiteo@yahoo.com
  * add more checks for STL parameters

Sun Feb  4 17:48:53 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * scaling down it not yet implemented in triangle space

Sun Feb  4 17:35:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * instead of updating buttons manually use updateInterface

Sun Feb  4 17:32:20 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * missed to update continue button in 2 places leaving it in a wrong state

Sun Feb  4 17:30:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * when copying a problem one member of class was not initialized

Sun Feb  4 16:51:40 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * more documentation updates, updated images for new interface, ...

Sun Feb  4 15:35:52 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * forgot to update makefile when exchanging pagoda jpeg to png

Sun Feb  4 15:30:23 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * don't make the existing space smaller than it is, center the transformed shape

Sun Feb  4 15:29:58 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * don't try to transform when the space is empty in voxel_1

Sun Feb  4 15:03:59 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * triangle voxel space now also uses rotation matrix for transformation rotation functions are removed

Sun Feb  4 12:23:26 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove some unneeded variables, mention Derek in AUTHORS for stl support

Sat Feb  3 22:05:11 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * doc: aftermath of nobreak inclusion

Sat Feb  3 22:04:38 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * some spaces must stay or texmacs will get confused

Sat Feb  3 22:01:52 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * document the new "Sym" column in status window

Sat Feb  3 21:56:00 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make sure all occurences of "3-D" are unbreakable

Sat Feb  3 21:55:24 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * doc: correct font for a gui element -> must be sans serif

Sat Feb  3 21:52:43 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * replace Pagoda jpeg with color reduced png file

Sat Feb  3 21:51:16 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * documentation changes for image export

Sat Feb  3 20:59:12 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add checks for gridtype and variable voxels to the STL export

Sat Feb  3 20:46:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * some improvements to STL export
  
  -remove whitespace at the end of lines
  -make static variables static
  -make filename string in export function as long as the snprintf calls expect it to be
  -inform the user with message boxes about reasons, why the export failed
  -remove unneeded headers and the not required multiple inherited class
  -clean up the dialog widget positions and give them some meaningful minimum sizes for the expected content
  -the piece selector takes up the rest of the available space vertically

Sat Feb  3 20:44:05 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a stretch function to layouter which maked the widgets stretch into the available space

Sat Feb  3 18:32:11 CET 2007  smiteo@yahoo.com
  * stl-export

Sat Feb  3 18:30:33 CET 2007  smiteo@yahoo.com
  * stl-export

Sat Feb  3 17:53:57 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * 17 new symmetry groups for triangle space

Sat Feb  3 16:56:37 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * introduce initHotspot function
  
  this function initializes the hotspot in a proper place
  sauitable for the gridspace so that the position of the
  hotspot stays valid through all possible orientations
  
  this is necessary for spheres as there it might happen that
  is turns out to be in a place that is not valid if the hotspot
  is always at 0;0;0, so with spheres we put the hotspot at
  a non empty voxel close to 0;0;0 all other spaces currently
  always use 0;0;0

Thu Feb  1 21:21:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add a column to the status window that shows whether the symmetries of all pieces are known

Thu Feb  1 21:09:29 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * 8 more symmetry groups for sphere space

Thu Feb  1 17:59:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add BallRoom and update other examples
  
  add comments everywhere, minimize where not done, add proper weight and resolve

Thu Feb  1 17:57:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * aftermath of the typo corrections, this is just reindenting of paragraphs

Thu Feb  1 17:56:20 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * simplify triangular minimisation and proper implementation for sphere minimisation

Thu Feb  1 17:17:37 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * the real headers have a capital letter H

Thu Feb  1 16:58:06 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * loots and loots of typo corrections for documentation

Wed Jan 31 21:40:05 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * documentation updates

Wed Jan 31 17:26:34 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * stop window going back to minimal size
  
  who is called when a windows is clicked and no widged in sight, show
  used to sed the window size, not it only does, when window invisible
  at that moment

Wed Jan 31 16:49:21 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix comment editing box problem with a too high label

Tue Jan 30 20:29:00 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper centering and move to origin for triangles and spheres

Mon Jan 29 21:49:02 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix color mark drawing in sphere grid editor

Mon Jan 29 19:19:18 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * mention Markus in AUTHORS for his hints with the spheres

Sun Jan 28 21:49:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * rotation matrices are static for module...

Sun Jan 28 21:48:18 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * use rotation matrixes for triangle space generator and point transformation, more will follow

Sun Jan 28 21:44:15 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * don't rotate a shape for bounding box calculation if not necessary
  
  this saves us cycles as this function is quite often called with 0 as
  transformation and the transformation sometimes changes things (e.g. in sphere
  space where after a transformation the space can get smaller...)
  This resulted in skips in rotated assemblies -> not proper rotated assembly reduction

Sun Jan 28 21:42:46 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix another skipping transformed assembly problem with triangle space
  
  the problem was that the (0,0,0) vector can not be rotated onto
  itself because of parity changes in the target triangle, so we have to
  consider this small shifts

Sun Jan 28 14:06:46 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * also include mirror matrices in sphere space 
  
  this allows us to remove the mirrorX function

Sun Jan 28 13:41:08 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * use rotation matrices in space grid 0 as well
  
  they are more flexible, the do now include the mirroring, so
  all transformations can be done in one step, which is way cheaper
  than the up to 4 copyings required to generate a transformation
  before (mirrorX, rot along all 3 axes...)
  
  It also removes quite a bit of code as the rotation functions have
  been quite big.
  
  Triangles will be switched over next

Sat Jan 27 20:57:34 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * virtualize scale functions and fix scaling for triangles

Sat Jan 27 20:00:56 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix centering of objects in sphere space

Sat Jan 27 18:10:13 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * use the axis colors for the size selector labels

Sat Jan 27 18:03:16 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove the grid space names from the tool tabs

Sat Jan 27 17:41:09 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * invalidate symmetry after rotating aroung z in triangle space

Sat Jan 27 17:39:42 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove all unneeded rotate and mirror functions, the ones left are private now

Sat Jan 27 17:19:51 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * now all grid spaces use no rotate and mirror functions any more in the gui

Sat Jan 27 16:59:22 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper rotations and flips for triangle space, also only using transform

Sat Jan 27 16:39:09 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper rotations and flips for sphere grid using only transform
  
  we will do that same for all grid spaces: only use transform, when we
  can remove the rotate and mirror functions from voxel space where
  they don't really belong as not all spaces can be rotated one way or
  another

Sat Jan 27 16:19:21 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper nudging for the new space grids

Sat Jan 27 16:18:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * it makes no sense to "scale" sphere grid space, so remove those buttons

Sat Jan 27 14:42:07 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * voxel actionOnSpace function now uses the getNeighbor function to find neighbors
  
  this used to be fixed coded and only worked for brick space, now also speres are
  working properly and it is possible to make inside spheres variable...

Sat Jan 27 13:47:31 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * initialize symmetries after loading voxel space

Sat Jan 27 13:47:12 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * missed one include file

Sat Jan 27 13:27:55 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * gzstream include must be local

Sat Jan 27 13:26:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * overhaul of build system, now the generated files in tabs_x are created automatically

Sat Jan 27 10:35:37 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add some symmetry search functions for spheres

Fri Jan 26 22:08:47 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make the triangle space generator independent from libburr, now we can include them in the makefile

Fri Jan 26 21:56:43 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make generator for brick space independent from burrlib

Fri Jan 26 21:30:39 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make generator for space grid 2 independent of library

Fri Jan 26 21:29:25 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * bitfield uses asserts

Mon Jan 22 19:09:10 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * Add Bill Cutlers Bermuda puzzle

Sun Jan 21 16:55:37 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * factor out size buttons of tool tabs

Sun Jan 21 16:34:46 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * factor out the code to resize a space in the tool tab

Sun Jan 21 16:26:42 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * factor out the tool button tab

Sun Jan 21 16:09:05 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * move 2 wigets only used by tool tab to tool tab file

Sun Jan 21 15:47:03 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * the tabs with the edit tools can now be different for all grid spaces
  
  right now they are 3 cpies of one and the same class, except for the small
  text difference to see, which grid space is active. Later on we will implement
  different tools for all the grid spaces or have different activities for
  different spaces (e.g. nudge only by 2 units, ...)

Sun Jan 21 13:25:44 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * huge speedup for layouter
  
  first when a layouter widget was resized it used to call the Fl_Group resize function, which first
  placed all widgets resulting in recursive layouter call for all those placements and then the 
  layouter placed the widgets again resulting in another recursive cascade. That is removed now by
  only calling the Fl_Widget resize
  
  second the minimum size of a layouter stays constant normally, so cache that value for later calls
  to the function.

Sun Jan 21 09:35:54 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix bug when calculating minimal tab size
  
  the width and height were not properly initialized resulting
  in huge sizes from time to time, now a minimal size of 10 is assumed

Sat Jan 20 17:34:25 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * simplify hotspot calculation in sphere space
  
  as the hotspot calculation might be done after the loops anyway
  we don't need to have that check inside the loop

Sat Jan 20 15:20:53 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix assembly rotation for sphere space grid
  
  2 things were wrong:
  - if the hotspot was on an empty voxel is was not updated when rotation
  - the transformation multiplication matrix was calculated wrongly, the mirror matrix was applied wrong

Fri Jan 19 21:51:23 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * copy and paste, bitfield print function doesn't need to maintain the index

Fri Jan 19 17:39:27 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * convert bitfield to use proper linebreaks (UNIX) and start using standard int types with lengths

Wed Jan 17 21:34:04 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix bug in loader for assemblies that made negative number below -9 load wrong

Sun Jan 14 21:30:04 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * make the puzzleSolver3D importer check for duplicates and explain the documentation about importing

Sun Jan 14 19:23:08 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add another missing file (bitfield)

Sun Jan 14 19:11:30 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add the assembler frontend for the sphere grid space

Sun Jan 14 17:38:40 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper deinitialisation of PieceVisibility viewer, valgrind complained

Sun Jan 14 17:35:01 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * simplyfy toggle 3D and grid editor function a bit, the layouter makes it possible

Sun Jan 14 17:30:12 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix layouting problem after toggling the 3D and the grid editor

Fri Jan 12 22:21:01 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * validate coordinates before editing them in grid editor
  
  this is necessary for sphere as they do have voxels that do not belong to
  the space but thay would be edited by the grid editor and would break havoc
  that way
  so a new virtual validate function is created with default implementation always
  valid and a specialisation for spheres.
  at the same time the recoursive set function is made a part of the class to have
  better access to class memebrs and now requires less parameters

Fri Jan 12 21:58:02 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * another 11 sphere symmetry groups

Fri Jan 12 21:23:14 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * search for all sphere symmetry groups of 3x3x3 spaces and add them

Thu Jan 11 21:15:30 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix spheres generator, the matrix multiplication was not stored correctly

Thu Jan 11 20:49:56 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * handle mirrors in sphere transformPoint

Thu Jan 11 20:49:20 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * 3 more symmetry groups for spheres

Thu Jan 11 18:16:56 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * fix transformPoint for triangles, this has been wrong a loooong time

Tue Jan  9 19:17:00 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper implementation for symmetry calculation tree in generator for space 2

Tue Jan  9 19:01:00 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * some more symmetry groups for spheres

Tue Jan  9 18:03:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * update generator for grid space 2 (spheres) now transformed assemblies are suppressed

Tue Jan  9 14:43:10 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add symmetries and assembler frontend for spheres

Tue Jan  9 14:42:20 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper hotpot update for transformation and correction to transform point in voxel_2

Tue Jan  9 14:40:50 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * nobody uses the symmetry mask directly, so remove that function and properly virtualize the only user

Tue Jan  9 14:39:30 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper positioning of spheres in the voxel drawer

Tue Jan  9 14:38:47 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * due to the large symmetry vectors of spheres, we need a lerget buffer here

Sun Jan  7 11:47:02 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper neighbors for spheres

Sun Jan  7 11:46:17 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add some pointers to one message, this message confuses people, so tell them where to read

Sun Jan  7 11:44:29 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * implement transformation for spheres, also toggle logic, (0;0;0) is a valid coordinate

Sat Jan  6 17:15:33 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add the missing files for the new space grid to darcs repository

Fri Jan  5 21:16:50 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * virtualize transform
  
  the transform function is really the work horse when it comes to generating alls
  possible orientations. It it the only function used for that by the libraray. the rotxyz
  functions are only used by the gui. So make transform virtual so that each class can
  have its own implementations as spheres nees another aproach and can not work with
  the current scheme of adding up several rotxyz calls. This also removes the rotxyz members
  from sym, as nobody needs them the rot arrays are now part of the voxel_x_c classes
  
  later on rotxyz will be removed from the voxel_c class as they are really dependend
  on the grid space if they do make a sense at all

Fri Jan  5 20:42:29 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * transformations can fail in sphere grid space, so we can not use it in constructor
  
  this patch removes the transform parameter from the voxel space constructors and
  places the transform call after that and either adds asserts or checks to in
  the right places to check for the result of the transformation

Thu Jan  4 21:21:34 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * remove parameters for the cube space they were no good aproach
  
  I need to think about this again but this is no good because the user
  - can not exactly define the shape to use and opten the resulting shape looked wrong
  - too complicated logic for the programming

Thu Jan  4 21:06:39 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add voxel_2 class, right now it is just a copy of voxel_0 plus the rotation matrixes

Thu Jan  4 21:06:14 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * NEWS, clarify disassembler

Wed Jan  3 20:39:57 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add spheres as a new possible space grid
  
  currently the grid editor and the voxeldrawer do work ok but still need improvement
  the variable voxel markers are missing
  no dedicated voxel space -> no proper transformations, no symmetry checks, ....

Wed Jan  3 20:39:35 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * typo in makefile generator in a filename

Tue Jan  2 18:24:21 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * add buttons to add one instance of all shapes and another one to remove all shapes

Tue Jan  2 18:23:20 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * better toggling of 3D area and grid editor
  
  it is still not perfect with the new layouter, but working at least again most of the time

Tue Jan  2 18:21:25 CET 2007  Andreas Röver <roever@users.sourceforge.net>
  * proper minimum size for grid edit group

Sun Dec 31 19:07:01 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make the rest of mainwindow use the layouter so now it is completely layouted

Sat Dec 23 21:11:17 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS file with a few more things

Sat Dec 23 21:09:04 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update stale comment

Fri Dec 22 14:45:01 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * enable and disable the new buttons on the solver tab when the puzzle is currently solved

Fri Dec 22 10:11:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a coment for the hash node reference count

Thu Dec 21 11:23:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the reference count increasing for the disassembly nodes to the proper place

Thu Dec 21 11:17:41 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * simplyfy disassembler find state loop a bit

Wed Dec 20 19:59:30 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * get rid of the deletelist in disassembler, use the reference counter of the nodes instead

Wed Dec 20 19:36:43 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * newNode always returns a valid value, so no need to check that

Wed Dec 20 19:36:12 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some comments

Wed Dec 20 19:33:51 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use a hashtable in the disassembler for node merging
  
  this used to be a list but the list can get up to 60 entries large and then
  checking all entries if they are equal to a new node can be expensive

Wed Dec 20 19:33:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some const correctnes

Wed Dec 20 19:32:50 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * cache the hashvalue for disassembler nodes

Sat Dec 16 18:15:07 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add some coments to the checkmovement function in disassembler

Sat Dec 16 18:06:09 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add missing include

Sat Dec 16 17:58:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * save direction and amount of movement with the disassembler nodes
  
  with this information the node merging can be done much faster because
  we don't need to find this information, also the newnode function was simplified
  because of some interface changes

Sat Dec 16 16:40:10 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * improve prepare2 function of disassembler
  
  not we only do another loop if it is really necessary, the check costs extra time
  but is doen't raise the level of the function. The function is still O(n^3) but
  we can save one of the n^3 loops

Thu Dec  7 18:10:54 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * more tweaks to node hashtable in disassembler
  
  - nodes are now a real hashnode instead of stored in a struct that is a hashnode. This
    saves us loooots of new and delete calls
  - hashtable starts smaller and grows faster

Wed Dec  6 21:11:57 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * optimisation for node finding
  
  when finding nodes don't save doubles. This should help improve performance
  because merging needs to be done with less nodes

Wed Dec  6 21:07:07 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * optimisations for newNodeMerge
  
  bail out as fast as possible, if we can not return a valid node
  so if the movement of pieces differ -> return

Wed Dec  6 21:05:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * optimisations for the check movement function
  
  one check is moved up so that the inner part can be avoided earlier

Wed Dec  6 21:04:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * improvements to node hash
  
  - the node hash can not grow
  - some optimisations for fatser initialisation and deletion
  - start with smaller hash table for less memory consumption

Wed Dec  6 21:02:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * change hash function for node hash so that is if faster to calculate

Tue Dec  5 18:25:51 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Checkmovement returns now only equal movement
  
  Checkmovement used to return different amounts of movement for different pieces
  that disturbed quite some other parts, now all pieces are wither stationary or
  move by the amount given to that function
  
  That also makes the check for even movement in the new node function unnecessary
  and so it could be moved over to the mergenode function

Tue Dec  5 18:24:50 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * burrTxt can now only redisassemble the already found assemblies in a file

Sun Nov 26 14:45:45 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * disassembler uses the max weight instead of the sum of the weights

Sun Nov 26 14:31:45 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Fix crash on toggling piece visibility when no solution is displayed
  
  When you toggled a visibility and for example the problem display ways visible in the
  3D window the program could crash because it tried to check the visibility for more
  3D shapes than there were blocks in the selector

Mon Nov  6 21:07:43 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use proper font for gui elements in documentation

Mon Nov  6 21:06:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * new images for documentation with new gui elements

Sat Nov  4 18:29:02 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some small additions and fixes to documentation

Tue Oct 31 19:00:20 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add status window to documentation

Tue Oct 31 18:58:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * mention different grid spaces in differences to PuzzleSolver3D

Tue Oct 31 13:15:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update documentation with space grid, weight and the new buttons on sovler tab

Tue Oct 31 13:13:57 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * doxygen commenting

Fri Oct 27 20:07:10 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the window frame from the images inside the documentation

Thu Oct  5 18:55:01 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a doxygen configuration file

Sun Sep 24 15:11:25 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * increase readability of code in the disassembler a bit

Sun Sep 24 15:09:58 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * use a hashtable in the disassembler to store closed nodes
  
  this should hopefully increase speed as the looup operation of a hashtable
  is way faster than the one in a binary tree as was used for the old set

Sun Sep 24 15:00:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a section with hints and tips for emulation other space grids. Right now only headers

Sun Sep 24 14:59:41 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add Ronald as author to the documentation

Sun Sep 24 14:51:04 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly reset groups after searching, this silences a warning

Sun Sep 24 14:49:39 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper padding for button groups to make them look like in the old version before going to layouter

Sun Sep 24 14:48:46 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix unused variable varning inside thr tr module

Sun Sep 24 14:47:29 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add possibility for buttons to specify padding between label and button frame

Sun Sep 24 14:46:03 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add virtual destructors for all classes that miss them

Sun Sep 24 11:58:49 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * gcc doesn't accept class::member inside the class declaration
  
  make compilabe with gcc 4.1.1

Tue Jun 20 18:38:53 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * small optimisation in disassembler_0

Tue Jun 20 18:25:58 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * assert to make shure we don't free more than once

Tue Jun 20 18:22:37 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * new disassm to moves option for better image generation
  
  now the active part, where things are moving is always in the
  center and not like in the old one where, when the removed
  part required further shifting, the action took place somewhere else

Tue Jun 20 18:20:38 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper local lables for the i86-asm part of the dancing link assembler, now it works again

Sun Jun 18 11:58:46 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * better disassembly breadth first search
  
  this search does keep only the nodes that are really required
  and drops nodes that are useless. This speeds up the process as
  less nodes need to be searched when a new node is included in
  the list it also saves memory as less nodes need to be saved
  
  The patch also fixes a problem with the old node merging algorithm
  which was wrong because of the weights and which also merges wrong
  nodes together

Fri Jun 16 16:23:26 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix crash for constrains buttons

Fri Jun 16 16:08:06 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * the custom progress bar is no longer needed (since fltk 1.1.7) so remove it

Fri Jun 16 14:07:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * 2nd batch of typos in comments and prints, this should be nearly all

Thu Jun 15 18:18:39 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * first set of typo corrections on comments and program output

Thu May 18 21:48:46 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * use local labels in assembler code

Sat May  6 15:40:43 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: typos and improvements to unix installation section

Sat May  6 09:58:48 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * wrong filename for ImageExport Window image

Fri May  5 22:21:56 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * convert the last section in the entities tab to layouter
  
  all that we need now is to write our own tile class that
  doesn't allow the dragging of widgets below their minimal size

Fri May  5 22:21:33 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * masure proper label size for buttons

Fri May  5 22:21:15 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for calculation of layoutabe tab size

Fri May  5 19:24:04 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: remove the table of contents its rebuild when creating the pdf

Fri May  5 17:13:34 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: fix section breat typo

Fri May  5 17:12:40 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add section for exporting images

Fri May  5 16:50:02 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add Ronald and Derek as a Thank you to the preface

Fri May  5 16:49:40 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: move caption lables behind the caption, otherwise TeXMacs gets confused

Fri May  5 16:49:04 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add the new documentation to the distribution

Thu May  4 21:46:40 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: add some unix installation instructions

Thu May  4 18:20:35 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: another toc update

Thu May  4 17:16:28 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: remove the reference and auxiliary data at the end of the file, they can be recomputed

Thu May  4 16:42:37 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: remove some items from future plans list

Thu May  4 16:41:59 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: mention that is might be impossible to continue after upgrading

Thu May  4 16:41:23 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: additional reason for not saving disassemblies

Thu May  4 16:39:25 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: some more typos

Thu May  4 16:38:30 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * doc: note that it _is_ possible

Thu May  4 16:36:08 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the name of the computer magazin

Wed May  3 21:55:12 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * first save in texmacs 1.0.6, update table of contents

Wed May  3 21:36:16 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * Ronalds new documentation
  
  this is more or less his' file, except that I removed the
  absolute paths of the images included in the tm file

Thu May  4 19:35:48 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * convert the tabs on the entity tab

Thu May  4 18:40:00 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * button size must use measure_label to determine the size of the button label

Tue May  2 16:31:06 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * convert solver section of solver tab

Mon May  1 21:16:54 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * solution section on solver tab

Mon May  1 17:31:01 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * constraint section of problem tab, problem tabl is now finished

Mon May  1 17:19:31 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * colors section of problem tab

Mon May  1 17:15:22 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * pieces section of problem tab

Mon May  1 17:01:36 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * shapes section of problem tab

Mon May  1 16:51:04 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * problem tab, problem section

Mon May  1 16:50:50 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * convert entity tab colors section

Mon May  1 12:38:12 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * replace hand placed widgets in the entities tab shape section with layouter
  
  this is just a first step. All other sections will follow, followed by
  a replacement of the tile group to make shure you can not
  drag widgets smaller than their minimum size. This will not be
  possible with the standard tile widget

Mon May  1 11:01:57 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove unused constructors from flat button class

Mon May  1 10:44:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup of file and class names in groups editor

Mon May  1 10:36:54 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename the class of the groups editor table

Mon May  1 10:34:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the table class of the groups editor into the c file

Mon May  1 09:59:06 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup for mainwindow file name and class name

Mon May  1 09:50:31 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * move includes in MainWindow from header to cpp file, this saves compile time for main

Mon May  1 09:33:44 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * clean up image export file and class name

Mon May  1 09:05:28 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * this include is no longer required

Mon May  1 08:50:10 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename configuration class to configuration_c

Mon May  1 08:45:36 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove openGL include from arcBall header

Sun Apr 30 22:03:53 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * and now the placement browser

Sun Apr 30 21:41:58 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * sort files in makefile alphabetically, well more or less

Sun Apr 30 21:32:40 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * image file and class names cleanup

Sun Apr 30 21:24:18 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup of disasmtomoves classes, moved them also into lib as they are not really gui

Sun Apr 30 21:07:46 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename pieceColor to piececolor

Sun Apr 30 21:01:15 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * ArcBall_c -> arcBall_c proper name for that class

Sun Apr 30 20:49:46 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename acrball file to all lowercase
  
  more files are going to follow. This is the start of a cleanup to
  get some kind of rules into filenames, and typenames

Sun Apr 30 17:02:42 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * merge VoxelView into voxelDrawer_c
  
  This needs some more cleanup, but there was no reason for the
  VoxelView base class any more

Sun Apr 30 17:02:08 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix static linking against flu and fltk

Sat Apr 29 13:58:31 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * set value of solution selector properly when activating first found solution

Sat Apr 29 13:51:32 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * select proper solution after deleting some of them

Sat Apr 29 13:44:28 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly place solution selector on Solver tab

Sat Apr 29 13:29:56 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement dropping of disassemblies and only keeping the disassembly information so save memory

Sat Apr 29 09:52:40 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * more updates to NEWS file

Fri Apr 28 22:10:59 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * simplify the already implemented sorting with new disassembly info class and implement missing
  
  we now only use the disassembly info for comparison. This class is always
  creates, even when the complete disassembly is available. Comparisons
  are faster with is anyway so it should be worth it

Fri Apr 28 20:27:25 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * update 2 puzzles with new weight feature

Fri Apr 28 16:37:37 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * update news file with new developments

Fri Apr 28 16:32:36 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement weights in the disassembler
  
  when the disassembler has found a new move it adds the weights
  off all pieces that move and all pieces that stay and if the
  weigth of the steady group is larger, this group is moved instead
  in the opposite direction

Fri Apr 28 16:31:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * solution number and assembly number should not be displayed in scientific form

Fri Apr 28 16:30:55 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add gui for the weight field

Fri Apr 28 16:28:33 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a field "weight" to voxel spaces
  
  this field will allow the disassembler to properly select which
  pieces to move. So it is possible to keep frames and boxes steady
  while the inner pieces move around

Fri Apr 28 16:27:09 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * replace internal structure of separation info class with something simpler
  
  this new version requires less memory it is a prefix order
  array representation of the tree, now we can save and load properly

Fri Apr 28 16:25:35 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * update news

Thu Apr 27 21:58:29 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper sort, even for solution info only cases

Thu Apr 27 16:51:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * when loading a disassembly info, check, if there actually is one

Thu Apr 27 16:44:19 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * show a window when recalculating all disassemblies

Thu Apr 27 16:38:14 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for function that removes information from movement cache for one piece
  
  the entry counter was not decreased, even when elements were removed

Thu Apr 27 16:37:27 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add possibility to display some information about the usage of the movement cache

Thu Apr 27 16:36:50 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add buttons to replace disassemblies by disassembly info and recalc disassembly and other things with disasms

Thu Apr 27 16:33:47 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for loading in assembler 0. The last entry may be not complete
  
  the last entry will only contains valid information for the
  status array, all other fields are too small anyway, so skip them
  for the last (meaning the one that is equal to piecenumber)

Wed Apr 26 22:03:11 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * show disassembly information, if present

Wed Apr 26 22:01:19 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add function to delete solutions without disassembly (info)

Wed Apr 26 21:55:58 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add separation info to puzzle and solution classes
  
  now you can have a treeInfo field, if the tree field is empty

Wed Apr 26 21:54:24 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a separation info class that contains part of the information of the disassembly class
  
  this part is the dificulty of the disassembly, the number
  of moves and the level information. This class will be used
  to have a more memory efficient way of saving the important
  information of a solution fr huge puzzles with lots of assemblies
  and many solutions

Tue Apr 25 20:31:51 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement proper removal of mirrored solutions from the list of found assemblies
  
  we have to try to exchange pieces that are mirrors of one another
  after doing the mirror transformation, to try to remove mirror
  orientations from the assembly
  
  The mirror pairs are detected in the prepare function and given
  to the assembly transform function via parameter

Tue Apr 25 20:00:31 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * initialize the edit choice once after startup

Tue Apr 25 19:24:37 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * initialize variable to make valgrind happy

Sun Apr 23 11:51:37 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove some unused code from assembly transformation

Sat Apr 22 22:44:00 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix in rotation check
  
  this fixes a problem, that occures, when the pivot piece contains
  mirror symmetries. Then the comparison works even, if there are
  mirrored shapes inside the transformed assemblies. Of course mirrored
  shapes are not available and so the assembly is invalid
  
  There is, of course the possibility to swap to pieces that are the
  mirror of one another. This needs to be inserted, but I will not
  do that right here

Thu Apr 20 17:57:15 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * the hotspot is in the center of the voxel given by its coordinates
  
  this simplifies the code because the hotspot doesn't change place
  when doing a rotation, as it was necessary for triagonal prisms
  
  It also allows toload the old savegames as they were calculated with this
  assumption and the had been changed a while ago

Thu Apr 20 17:56:26 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * print some more information when showing a voxel space

Thu Apr 20 17:55:38 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove debug code, no longer required I assume the code is working

Wed Apr 19 16:42:54 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement solution sorting and deletion of solutions

Tue Apr 18 18:10:30 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove no longer needed parameter from checkmovement function

Tue Apr 18 18:06:43 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper solution for the multi-piece movement checks, also add some consts, where suitable
  
  this solution is also much faster. It creates all merges with all
  already found movement nodes with each new found node instead
  if checking the movement possibility for groups of 2 pieces

Mon Apr 17 19:03:49 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix warnings

Mon Apr 17 19:02:12 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * replace fl_ask with fl_choice, as the first one is going to be removed and results in warnings

Sun Apr 16 20:47:04 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * z size doesn't change in rot z

Sun Apr 16 20:46:05 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix warnings

Sun Apr 16 20:45:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix warning

Sun Apr 16 20:35:08 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't use that strange deallocate template any longer, the for loop is simpler to understand

Sun Apr 16 20:33:43 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * if drop solutions, we must free them

Sun Apr 16 20:33:03 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * we need to free the voxel spaces in the voxelviewer, when the viewer gets deleted

Sun Apr 16 20:32:44 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * free gui grid map, when main window closes

Sun Apr 16 20:32:01 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * now the prixmapList also for the images directly in the main window

Sun Apr 16 19:00:49 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * widgets don't free assignes images, so we need to do that
  
  this is handled by a new class that has a list of all allocated
  images. The class is used for the tool tab images, others are still
  missing

Sun Apr 16 19:00:24 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add destructor for pieceVisibility list to free allocated memory

Sun Apr 16 11:20:34 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the changelog creation at the start of the bootstrap script, as the other commands need it later on

Sat Apr 15 18:41:25 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * when the list gets full for unsorted entries, we now keep only every 2^n-th entry

Sat Apr 15 16:34:20 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * save the assembly and solution number with each solution

Sat Apr 15 10:05:18 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * multi-pieces must not be symmetry breaker, it may break the assembler

Fri Apr 14 22:36:54 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add possibility to limit the number of solutions saved
  
  this doesn't work right now for assembly only solutions
  as it can only make a choice for solutions with disassembly
  by dropping the less interessant solutions

Fri Apr 14 14:10:01 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add gui for sort method functionality in last patch

Fri Apr 14 12:19:06 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * assembler thread can now sort n different ways, implemented level sort
  
  level sort sorts so that the highest level is at the top
  if the first level is equal the 2nd level is used for comparing

Fri Apr 14 11:06:48 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the sorting of solutions out of puzzle, into assemberThread
  
  this is the 1st step in making a more powerful solution saving
  engine with more choice for the user, like different sorting
  saving only parts of the solutions, ...

Thu Apr 13 21:49:01 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * lower changes for the occurance of a fatal problem with the assembler
  
  the problem occures when a multi-piece is selected as symmetry breaker
  and later on a voxel is selected that can not be filled with the 1st
  of the multi-piece and thus the 2nd gets selected.
  
  The "solution" right now is to try to not choose a multi-piece as symmetry
  breaker even if the symmetry conditions are better.
  
  Now the problem can only occure in problems that have only multi pieces

Thu Apr 13 21:21:40 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix merge confloct with patch "fix assembly rotation with non minimized result shapes"

Wed Apr 12 21:23:10 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix assembly rotation with non minimized result shapes

Wed Apr 12 18:17:22 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * some capitalisation corrections and resize of the "Apply to all Shapes" element

Wed Apr 12 17:13:20 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * draw the grid of the solution when showing the assembler step

Wed Apr 12 17:12:59 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper centering for the assembler step viewer

Wed Apr 12 17:12:02 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * the 2 checkboxes in the solver tab are in the same line now

Tue Apr 11 18:08:05 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * one more symmetry for space grid 1

Tue Apr 11 17:03:43 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove unused variable and widget class

Mon Apr 10 21:43:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * count and print number of removed rows and columns in reduce

Mon Apr 10 21:14:16 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * program now tries to load all command line options and stops at the first successfully loaded one

Mon Apr 10 19:45:03 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * use a contrasting colores in boxes in the shape status table

Mon Apr 10 17:45:12 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper solution for the hole checks and the handling of the outside

Mon Apr 10 16:50:15 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add darker lines to status window for easier viewing

Sun Apr  9 17:58:56 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove functionality from tester that has been moved to the generator programs

Sun Apr  9 17:53:33 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove some not needed pieceColor.h includes

Sun Apr  9 17:47:14 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * provide an integer function for the piece color and simplify most occurances

Sun Apr  9 17:23:43 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS with status window

Sun Apr  9 16:35:48 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the 2 pack files, they don't belong into the repository

Sat Apr  8 21:21:00 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper virtual functions for voxel neighborhood and according implementation for connectedness

Sat Apr  8 19:36:26 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * Add color markings for important information in status window

Sat Apr  8 18:37:30 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for identical comparison in status window, it was not compared against first shape

Sat Apr  8 15:20:29 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * make status window really usable
  
  the status window now includes connectivity information
  for the shapes, meaning is the complete shape conneced
  with faces, edges or only corners
  and does the shape contain a hole in 2D (z-direction is
  not considered) and 3D

Sat Apr  8 10:40:45 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the prepare functionality into the assembler mking the frontend classes much slower with this
  
  the prepare function can still be overwritten, if necessary, but for
  the current 2 space grid only the piece fits function differ by one line, so
  this saves us about 5kByte code

Fri Apr  7 21:50:21 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a basic status window containing some information for the current puzzle

Fri Apr  7 20:04:23 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * and another symmetry for space grid 1

Fri Apr  7 17:59:22 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * 7 new symmetries for space grid 1

Fri Apr  7 17:08:12 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a transform point to voxel space
  
  this function does a transformation on a given point around
  the origin
  
  this is used in assemly to transform the placement point of
  the given placements when transforming the assemblies

Fri Apr  7 17:03:58 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * try to avoid increasing the voxel space size when rotating around z axis

Fri Apr  7 17:02:09 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * virtualize identicalInBB and proper implementation for voxel space 1

Fri Apr  7 17:00:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * another new symmetry type for space grid 1

Fri Apr  7 16:59:32 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly center the placement browser display by useing the grid size calculation

Fri Apr  7 16:43:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * header time: add missing GPL headers

Fri Apr  7 16:41:11 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a hotspot checker to the test program

Thu Apr  6 21:44:59 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix the default version for the bounding box, the output pointers can be null

Thu Apr  6 21:19:14 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * corrections to hotspot calculation in voxel 1

Thu Apr  6 21:18:41 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * corrections to hotspot calculation in the old voxel space

Thu Apr  6 19:05:39 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * insert a bit of (commented out) code that can draw the hotspot

Thu Apr  6 19:04:37 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * hotspot values need to be corrected according to the voxel space

Thu Apr  6 16:43:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * impelement assembler frontend for space grid 1 and activate it

Thu Apr  6 16:43:19 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement proper hotspot calculation for voxel space 1

Thu Apr  6 16:38:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement comparison function that also looks for rotations

Thu Apr  6 16:28:56 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a function to tester that allows calculation of symmetries

Thu Apr  6 16:28:26 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * some better indentation

Thu Apr  6 16:28:14 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove generated code from symmetriy class files into inc files
  
  We now have as source only the possible rotations and the symmetries
  All other tables are calculated and written into include files that
  are used by the symmetry classes. This generation is done by the
  generator program, as this needs a working library bootstrapping
  is a bit complicated
  
  this patch also removes the class definition of symmetry_0 in the
  symmetry header file

Wed Apr  5 21:50:07 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * constructors for the voxel spaces are public again

Wed Apr  5 21:21:55 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper bounding box calculation after rotation in voxel space 1 round x and y axis

Wed Apr  5 21:20:39 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * virtualize mirror functions and provice proper implementation for voxel space 1

Wed Apr  5 20:58:34 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * the print routines didn't honor the hotspots until now

Tue Apr  4 21:44:48 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * move class global variable into function that only uses it

Tue Apr  4 21:34:29 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove warning from voxel 1

Tue Apr  4 21:33:33 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * divide the symmetries file into base and grid space version 0

Tue Apr  4 21:13:54 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement rotation around z axis for voxel type 1

Tue Apr  4 17:12:45 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove minimize function from voxel, as it is not used

Tue Apr  4 16:59:56 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper minimisation for voxelspaces of type 1

Tue Apr  4 16:58:39 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the necessity to call gridTypeChanged in constructor of voxelDraw inherited classes

Tue Apr  4 16:58:11 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * mention that the triandgular prisms space grid has no assembler and disassembler

Mon Apr  3 21:14:24 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * create specialized voxel space for grid type 1, rotation along z axis not not working

Mon Apr  3 18:36:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * virtualize bounding box and hotspot calculation, provide generic but slow default

Sun Apr  2 20:09:48 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * make compilable for apple

Sun Apr  2 20:15:41 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove dead code from gridType_c and also check for available assembler and disassembler before solving

Sun Apr  2 16:07:37 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * start version 0.2.0

Sun Apr  2 16:07:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper frames for voxeldrawer 1

Sun Apr  2 11:29:47 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * make sure only visible surfaces are drawn and also the variable markers are only drawn on visible surfaces

Sat Apr  1 18:10:06 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * prepare for release of 0.1.9

Sat Apr  1 14:24:50 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * better frame drawing, outsides of inside corners are no longer framed

Sat Apr  1 13:29:04 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement frame drawing

Thu Mar 30 18:30:50 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove Region checking function to voxelDrawer base class

Thu Mar 30 18:19:14 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the grid drawing functions into the base class

Thu Mar 30 18:06:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * factor out the voxel space drawing function from the voxelDrawer subclasses

Thu Mar 30 17:40:04 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper cursor for voxeldrawer 1

Wed Mar 29 21:22:27 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * missed to initialize a member of gridtype when loading from xml node

Wed Mar 29 17:19:39 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * some comments and cleanup to the grideditor header file

Wed Mar 29 17:18:28 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * some improvements to dialog layout and a note saying what the parameters of gridtypes mean

Wed Mar 29 17:17:35 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for anchor triangle position

Wed Mar 29 17:16:44 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add virtual function to calculate the display size of a voxel space and use that for centering

Wed Mar 29 17:16:19 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add assert to make sure we actually have a symmetry class

Wed Mar 29 17:15:59 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix case with break

Tue Mar 28 21:47:16 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly draw voxel space 1 base unit and the vraible voxel markers, the frame is still missing

Tue Mar 28 18:43:28 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * factor out the other functions of the grid editor classes

Tue Mar 28 17:20:19 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * factor out handle from grid editor classes into base class

Tue Mar 28 16:41:12 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * Implement mouse position calculation and cursor drawing for grideditor 1

Mon Mar 27 21:37:34 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * enable displaying of constraing colors in grid editor 1

Mon Mar 27 21:31:01 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * grid editor 1 can now draw the grid but without cursor and without color markers

Mon Mar 27 17:36:03 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add templates for the triangular prism space grid, these are right now only copies of the brick types

Mon Mar 27 17:24:20 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * grid type selector window now toggles parameter panes

Mon Mar 27 17:11:48 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * add the triangular grid types and all the necessary cases, filled right now with placeholders

Sun Mar 26 16:46:55 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * stop is also possible in preparation phase

Sun Mar 26 12:17:17 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * the grid editor and 3d view are replaced now, when a new puzzle is puz into the window

Sun Mar 26 12:11:45 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove commented out code and add destructor to gridType_c

Sun Mar 26 12:11:14 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * initialize all variables in grid editor

Sun Mar 26 12:10:52 CEST 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper save and load routines for the BRICK grid type

Sat Mar 25 21:06:50 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * button closes the grid type windows, also fix 100% CPU load with parameter window

Sat Mar 25 20:33:16 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * 3d view now responds to axis lengths

Sat Mar 25 19:29:38 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * initialize gridType properly and make the widget usable and the values consistent

Sat Mar 25 17:45:32 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * first version of the grid type selector window

Sat Mar 25 14:41:38 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper initialize bounding box for empty voxel spaces on construction, don't do anything on centering empty spaces

Sat Mar 25 14:40:25 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Ronald prefers the plural for the first tab title :-)

Sat Mar 25 16:12:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add first version of the dialogs required for grid type parameters

Fri Mar 24 22:11:47 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix "Piece x can be placed nowhere within the result"
  
  the preparator didn't return the shape id, but the index
  withing the pieces of the problem, this could lead to strange
  behaviour when the pieces were not sorted

Fri Mar 24 21:58:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * plus memory leak in burrTxt

Fri Mar 24 22:01:09 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix merge conflict in voxel_c

Fri Mar 24 21:57:43 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * switch from char * to std::string for shape names

Fri Mar 24 21:56:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * plug 2 memory leaks in disassembler, 2 objects were not freed

Fri Mar 24 21:26:57 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly handle voxel drawing with base class and concrete voxel drawer for cubes

Fri Mar 24 16:49:09 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * stop also works when currently disassembling

Fri Mar 24 16:48:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * also clear color information when emptying a cube in the voxel space

Thu Mar 23 18:15:24 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add the GPL file header

Thu Mar 23 18:10:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename SquareEditor to gridEditor_0_c
  
  this also lead to some cleanup within the usage of the enums
  and also the functions in the guigrittype factory are const

Thu Mar 23 17:46:56 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * introduce gridEditor_c as base type for SquareEditor
  
  this is highly probable not the right final solution but a start

Thu Mar 23 17:03:54 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * introduce guigridtype class
  
  this class is the factory for the grid type dependent widgets
  just like gridtype class is the factory for the parts of the library

Thu Mar 23 17:01:47 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * get rid of the label in the voxel drawer and voxel view widgets

Mon Mar 20 20:46:35 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fit burrTxt and convert for latests library interface changes (gridType, ...)

Mon Mar 20 20:36:21 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * bitrot on tester, lets for now comment out most of it, we will care for the useful functions later on

Mon Mar 20 20:25:24 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * voxel_c is not the base class for all voxel classes, voxel_0_c as usual the subclass for bricks
  
  for now only the rotate functions are virtual, but more are surely to come

Mon Mar 20 17:18:49 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the missing 2 voxel constructors to factory creation
  
  This patch temprarily disables the currently unused the piecegenerator

Mon Mar 20 17:18:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * missed copying the symmetry class then copying assemblies

Mon Mar 20 16:46:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some optimisations in tester and add functions to analyze parallel epipedions in tester

Mon Mar 20 16:43:41 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * also update the result id, when a shape is removed from a problem
  
  this fixes a crash, when opening the puzzle tab, because of an
  invalid result shape id. The id was for the last shape, one shape
  was deleted, the result not updated, and became invalid

Sun Mar 19 21:49:04 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * comment out the possible future gridTypes, they only create warnings

Sun Mar 19 21:36:32 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove constness from gridType in puzzle
  
  this is required because the parameters of the gridType
  are in fact editable, you can just not change the type
  itself

Sun Mar 19 21:29:30 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move symmetry creation to gridType factory

Sun Mar 19 21:16:13 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move assembler and disassembler into gridType factory

Sun Mar 19 20:51:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move voxel creation to gridType factory

Sun Mar 19 18:24:36 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * introduce gridType_c and make symmetries to a class
  
  This will finally lead to grid type independent code
  right now it replaces the define NUM_SYMMETRIES by the
  value sreturned by grid type and on that way introduces
  the class wherever necessary

Sun Mar 19 15:54:52 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * check result shape id after loading and reset, when invalid

Sun Mar 19 11:46:21 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * AUTHORS and NEWS updates

Sat Mar 18 16:40:25 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove a warning

Sat Mar 18 13:48:31 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * another update to symmetry calculation and avoidance
  
  The last update solving the squarrel bug resulted in a huge slowdown
  of JayCube because another piece was choosen for the symmetry
  breaker. This update results in JayCube using again the right
  piece for symmetry breaker. It passes the regression tests, so
  let's hope it's right

Sat Mar 18 10:54:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix bug with multi pieces that prevented finding solutions sometimes
  
  This bug occured in the multiPieceWhy puzzle file in the regression
  tests. THe problem was that the program expects to have at least
  n possible placements for a piece that occures n times, otherwise
  it is not possible to place them all. But the special first piece
  might have only one placement removing that from all the others
  and thus all other pieces might have only n-1 placement and that is
  still valid ad the last placement is in the first piece

Sat Mar 18 10:54:12 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename tabs in GUI

Sat Mar 18 10:52:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make problem selectable in the command line program

Fri Mar 17 17:58:58 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make sure we have a valid problem selected when there is one

Fri Mar 17 17:14:52 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * reorder some mnemonics to achieve better memory access parallelity

Fri Mar 17 17:13:11 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the 2nd updown entry from the assembler list of inputs

Fri Mar 17 17:06:20 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * merge the up and down array into one
  
  This frees one register for the assembler versions of the
  cover and uncover routines for intel cpus and this one
  free register allows for a much cleaner implementation without
  using stack and with 2 nearly identical implementations for both
  routines

Thu Mar 16 21:51:45 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * first version of an assembler implementation

Thu Mar 16 21:50:50 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * spelling of visible texts

Wed Mar 15 16:36:32 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * swap the sub block number to a place before the piece name in the piece visibility list

Wed Mar 15 16:33:22 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update year for copyright in about box

Tue Mar 14 16:59:36 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix deadlock when pressing stop after the thread has already been finshed
  
  This is not completely save, but should work in most circumstances
  (it might fail when the thread stops between the start of the routine
  and the setting of the state)
  
  Also unpress the button

Tue Mar 14 16:36:07 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * rearrange the elements in the size changing tab a bit

Sun Mar 12 18:57:03 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add separators for the other drag points in the problem tab

Sun Mar 12 18:45:00 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * take focus shortly when clicking into grid editor, this makes shure values are taken over from input lines

Sun Mar 12 18:30:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * do update the pieve visibility selector then the number of pieces changed
  
  this bug was introduces when not updating the selector when you
  just select another solution to not reset the state. But now it
  was possible to add new pieces to the selector and it didn't update
  this is fixed now

Sun Mar 12 18:14:21 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make solution selector start from 1 instead of 0
  
  also check, if the current value of the slider is not
  bigger than the number of solutions (can happen when switching
  problems)

Sat Mar 11 17:24:03 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for Browse placement button not enabled after a puzzle has been completely analyzed

Sat Mar 11 17:23:42 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add the latest speedups to NEWS file

Sat Mar 11 17:07:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup and comments here and there

Sat Mar 11 14:42:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a placement removal phase before the reduction that is a more general form if the recently added speedup
  
  Its something like this:
  for a column c1: if there is a column c2 that has a 1 in each row c1 has a one then you can remove
  all rows that have a one in c2 but not in c1 because it is required for c1 and c2 to be one at the same time.
  
  this thinns out the matrix before the more expensive piece placement phase comes

Sat Mar 11 13:13:01 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * speedup for reduction
  
  the idea here is that if one piece occupies certain unit in all
  its placements it is impossible that any other piece can
  occupy that unit, so all placements for any other piece that
  uses that voxel can be removed. This lets the matrix shink
  must faster and saves us some of the costly cover and uncover
  operations. The results can be quite enormous: One of frans
  polycube puzzle where you put the pieces onto sticks went down
  from 377 to 27 seconds.

Sat Mar 11 13:11:06 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some cleanup in assembler
  
  reformulate some while loops to for loops, that is easier to read

Fri Mar 10 22:31:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some cleanup and useless code removal in reduce

Fri Mar 10 21:55:31 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add clumps concept to speed up assembling of some puzzles
  
  This is taken from Bill Cuttlers program. In my implementation
  it means that we remove columns that are identical within the matrix
  as they don't contribute any information

Wed Mar  8 17:48:51 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some more updates to the NEWS file

Tue Mar  7 20:58:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename file pieceGenerator to piecegenerator

Tue Mar  7 20:56:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename file AssemblyCallbacks to assemberthread

Tue Mar  7 20:46:50 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename assemblerThread to assemblerThread_c

Tue Mar  7 20:41:14 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * rename movementCache to movementCache_c

Tue Mar  7 19:12:53 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add bt_assert this file should have been there for a long time :-(

Tue Mar  7 19:05:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add option to enable/disable fade out of pieces that are removed in the animation

Tue Mar  7 17:11:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Window title for placement browser

Tue Mar  7 17:08:54 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add a close button to the browse placement dialog

Mon Mar  6 19:33:04 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * and another symmetry group

Mon Mar  6 19:21:44 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * comments and cleanup for groups editor

Sun Mar  5 20:17:55 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove warnings in scale function

Sun Mar  5 20:15:51 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * include dependency cleanup
  
  this will hopefully remove some header dependencies and make
  compilation faster

Sun Mar  5 15:15:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup and comments for image export files

Sun Mar  5 12:05:09 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup and commenting of image class files

Sat Mar  4 18:08:52 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup and valgrind errors removed (uninitialized variables)

Sat Mar  4 17:33:43 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * save aa in imageInfo and so get righ of aa calculation in PostDraw routine

Sat Mar  4 17:31:20 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * simplify the setup for the image export

Sat Mar  4 17:31:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * plut memory leak

Sat Mar  4 17:12:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * restructuring of image export
  
  image export is now done inside the callbacks of a voxelView class
  this is necessary because otherwise (e.g in the thread) the openGL
  context might be absent, this will also enable us to support later
  new voxel space types without a lot of work

Sat Mar  4 17:10:56 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * divide the image grabbing into 2 parts
  
  so that we can put these into the VoxelView callbacks
  also get rid of the OpenGL setup, as it's now done in the
  voxelView and we don't need that any longer

Sat Mar  4 17:06:31 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * restructuring of voxel output classes
  
  now voxel view is the base and responsible for rotation, scaling
  ligtning, ...
  
  voxelDrawer is only responsible for drawing cube based voxel spaces
  
  also add a callback class to VoxelView to make is possible to
  call functions pre and post the drawing of the voxel space

Wed Feb 22 21:40:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Rework image export into state mashine Part III
  
  now the image output is done in small steps that only draw
  one image ino the OpenGL context and then return.
  What is left is to integrate this into the VoxelDrawer

Wed Feb 22 19:51:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Rework image export into state mashine Part II

Wed Feb 22 18:47:04 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Rework image export into state mashine Part I
  
  The image export can not be done in a thread, bu we need to do it
  in the draw function, but for that not to freeze the application
  we need to be able to do everything in small steps, this
  is the first part of this work

Wed Feb 22 18:20:26 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove unused variable, also remove the switch to the GL_BACK buffer

Wed Feb 22 16:30:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * improvement to scaleDown

Wed Feb 22 16:30:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix typo

Wed Feb 22 16:30:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * disable left arrows when no shape or no problem is available

Wed Feb 22 16:29:38 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * initialize variable properly

Wed Feb 22 16:29:15 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add one more future addition to documentation

Tue Feb 21 21:10:32 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * NEWS and AUTHORS updated slightly

Tue Feb 21 20:56:42 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make 2 module local functions static

Tue Feb 21 20:46:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * windows requires the glext header for openGL 1.2 functions

Tue Feb 21 20:28:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement downscaling

Mon Feb 20 17:58:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * deactivate z-mask writing, when outputting the transparent pieces
  
  This will make the rendering of the transparent objects more independent
  of the orientation the object, but they still change while rotating
  
  also a bug was fixed. 1 is opaque alpha value and not 255

Sun Feb 19 20:43:14 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move image export into thread, this enables a progress report in the status line

Sun Feb 19 18:11:55 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove useless empty lines, add GPL header to 2 files, add one missing header exclusion #ifdef __xx_H__

Sun Feb 19 17:46:11 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some comments for DisasmToMoves

Sun Feb 19 17:39:55 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * after doing File->New with a puzzle with shapes and then adding a new shape to the empty puzzle wouldn't update the 3D view

Sun Feb 19 17:28:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * comments and some cleanup for grid editor

Sun Feb 19 16:44:43 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use the active flag instead of my own lock flag in the grid editor

Sun Feb 19 16:21:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * reformatting and comments for piece color module

Sun Feb 19 16:20:35 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use the provided functions for lighting up and darking down the checkerboard pattern in the 3d view

Sun Feb 19 15:57:07 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement default sizes for the image exporter

Sun Feb 19 12:09:17 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * also use MY for the squares on the variable cubes

Sun Feb 19 12:04:39 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add comment for a define value

Sun Feb 19 11:29:35 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't increase light of dimmed pieces that much any longer

Fri Feb 17 23:06:52 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * do transparent object drawing always at the end to make them appear in front of opaque ones

Fri Feb 17 23:02:10 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * improvements to 3D view
  
  - remove lightnig dependency on scale
  - get rid of wideangle camera for big objects

Fri Feb 17 20:45:02 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make the size of the edge variable at runtime, so that dimmed pieces can be drawn without edge

Fri Feb 17 20:24:15 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the showColors parameter, it was not used

Fri Feb 17 18:12:17 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement dimming of non moving pieces for image export

Fri Feb 17 13:58:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix crash when stepping after the assembling has finished searching

Fri Feb 17 13:31:11 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * include a prepare button that makes the placement browser and the assembly debuggin more easily accessible

Fri Feb 17 12:54:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly clear status line, when doing "new puzzle"

Fri Feb 17 12:52:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make placement browser and image export window modal

Fri Feb 17 12:44:53 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly clip the grid editor group

Fri Feb 17 11:43:37 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * left align shape column in goups editor

Fri Feb 17 11:43:07 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use the shape labels and sort the shapes and pieces nicely for the CubeInCage puzzle

Fri Feb 17 11:38:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * higher inisital section size for section with shapes

Fri Feb 17 11:34:30 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use same scheme for copying problems as for shapes. The copy has no name and user can label it later

Thu Feb 16 20:29:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove all that not required linebreak stuff for image alignment

Thu Feb 16 20:08:56 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add case for export of problem

Thu Feb 16 20:07:51 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * seems like on my linux the grepped images are not transparent, so we have to change bg to transparent

Thu Feb 16 16:34:02 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement first version of solution export

Thu Feb 16 16:33:12 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * simplify opengl image constructor interface

Thu Feb 16 16:30:31 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement blit and minimalize width in image class (needed for export)

Wed Feb 15 22:12:50 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * updates to ImageExport Window (more window elements work now

Wed Feb 15 22:12:20 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * const accessors to the voxelView class

Wed Feb 15 22:10:57 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some header #ifdex exlusions were missing

Wed Feb 15 22:09:09 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move all image OpenGL generationstuff into image class

Wed Feb 15 22:02:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make the addTransformation function const; moving an only locally used variable to stack

Wed Feb 15 21:29:10 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * "for all" only works with the size tool tab and not transformation and contrain tab

Wed Feb 15 21:28:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * sizes only increase for all but the active shape, if "for all" is active

Tue Feb 14 18:18:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * SYMMETRY_GROU_O_PS -> SYMMETRY_GROUPS (fix typo in name)

Tue Feb 14 18:17:30 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix problem with exchanging 2 shapes in a problem

Tue Feb 14 18:16:44 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update some comments in the sourcecode that were quite outdated

Tue Feb 14 18:15:12 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix version discrepancy in assembler load and save and also make it more robust to errors in the xml string

Tue Feb 14 18:14:46 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some documentation updates

Mon Feb 13 21:49:02 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * correct problem with Placement Browser Button no longer getting disabled

Mon Feb 13 21:48:30 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update example files with the results of the improved disassembler

Mon Feb 13 17:40:00 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * properly clean problem status line when no information is available

Mon Feb 13 17:34:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't add shapes as pieces that are the result, and remove shapes from piece list when set as result

Mon Feb 13 17:09:47 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * never add groups with count of 0
  
  fixes issue in the group editor where you clicked on a
  cell and entered 0 and the cell turned colored even if
  the group size has been 0

Mon Feb 13 17:02:22 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * apply any open edit boxes in the groups Editor before closing

Mon Feb 13 16:11:25 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * group numbers don't need to be incremented as group 0 always exists

Mon Feb 13 15:51:35 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * correct title for color editor when changing colors

Mon Feb 13 15:44:57 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * edit mode as a config option

Mon Feb 13 15:33:16 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * right mouse button always clears grid cells in grid editor

Mon Feb 13 15:32:44 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * correctly set up colors when loading a puzzle

Sun Feb 12 20:40:37 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * show number of pieces in problem

Sun Feb 12 20:34:11 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some little text changes for tooltips and headers

Sun Feb 12 20:26:53 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * Show Shape name and correct number in group editor

Sun Feb 12 18:59:42 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * display vixed, variable and sum of both in the shape status line

Sun Feb 12 18:52:00 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't use different size ticks for the LineSpacer (used for z-layer selector) doesn't work well

Sun Feb 12 18:47:00 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * warn uses when opening a file containing a paused solution search

Sun Feb 12 12:25:49 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * corrections for the calculation of the symmetry breaker
  
  the old version did check against the symmetry bitmask of the shape
  in its current position. But now we do check against the unified bitmask
  of all symmetry bitmask of the shape in all its 48 transformations

Sat Feb 11 22:20:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update documentation with more possible future projects

Sat Feb 11 22:00:55 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * blocklists honor active state in when they are drawn

Sat Feb 11 09:49:19 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * used wrong problem selector for piece browser

Fri Feb 10 22:29:44 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use integer input instead of value inputs for the size input fields
  
  this alows to correctly set the callbacks when fields are edited
  with value input the callback comes whenever the user changes 1 digit
  now we only get the callback when the user leaves or presses enter

Fri Feb 10 21:39:46 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * new shapes have the size of the currently selected one

Fri Feb 10 21:33:13 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't allow focus on widgets that don't accept keyboard input

Fri Feb 10 17:06:01 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix move to origin

Fri Feb 10 17:04:09 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * improvements to image export
  
  now the size is honored, the window is much better, antialiasing
  and background settings are honored, image is not longer top down, ...

Thu Feb  9 20:45:36 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * better tooltip text

Thu Feb  9 20:35:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * link sizes, checkbox to make operations on tool tab to all shapes

Thu Feb  9 11:15:58 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix problem with color selector and piece selector
  
  need to select neutral color, when it's shown
  when deleting last shape don't select the 0

Thu Feb  9 11:13:52 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * new images for scaling and shifting by ronald and corresponding functions implemented
  
  The minimum scale function is missing, everything else should work
  also the scalers do now have input fields instead of only scrollers

Wed Feb  8 13:22:26 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix bug when adding the first shape
  
  when the list was created the selected element has been 0
  even though there has been no element
  and thus no update was made, when the selection
  was set to the first piece

Wed Feb  8 13:08:15 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the rubbish the the growing number of digits for the progress bar, it didn't work

Wed Feb  8 13:02:06 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * better progress bar with better colored label

Tue Feb  7 20:56:49 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some comments

Tue Feb  7 16:52:47 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix problem with nonminimized pieces and assembly rotation

Sat Feb  4 11:50:21 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS

Sat Feb  4 11:47:34 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * increase version of assembler, so old saved puzzles can not be continued with the new assembler

Sat Feb  4 11:44:11 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * huge improvement for assembly engine for puzzles with many identical pieces

Thu Feb  2 21:11:33 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add some simple debug facilities for the assembler
  
  with that come 2 bugfixes in the getAssembly routine that never
  came to surface because it was only called when the puzzle
  was completely assembled, but now it can also be called with
  a partial state of the assembler

Thu Feb  2 17:13:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * disable the brose placement button, when assembler is running

Thu Feb  2 17:12:45 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * display percent values in the progress display

Wed Feb  1 18:14:58 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * simplify function getPiecePlacementCount
  
  seems like I have been not myself when I wrote that function
  we always have the number of rows in a column in the column header

Tue Jan 31 20:26:21 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix crash when file given on command line didn't exist

Tue Jan 31 20:00:28 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for the independent zoom levels, the slider was not updated properly

Mon Jan 30 19:40:26 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix problem number in status bar

Mon Jan 30 19:40:12 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * missing include

Mon Jan 30 18:57:42 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * problems with empty names, rename the "rename" button to "label"

Mon Jan 30 17:47:02 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * more color names removed from xpm images (hopefully all now)

Mon Jan 30 17:20:04 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * correct typo

Mon Jan 30 17:19:46 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use prefix C for color lists

Mon Jan 30 17:18:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * lots of comments

Sun Jan 29 22:17:56 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use S prefix for shapes, P for Problems and then Sx - Label for piece description

Sun Jan 29 22:17:12 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix the update for the piece visibilty only then puzzle or problem changes

Sun Jan 29 15:55:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't clear the piece visibility state when changing the only the solution

Sun Jan 29 13:39:02 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add the F-keys to the tooltips

Sun Jan 29 12:55:50 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use shape name for result viewer, bigger viewer so that longer names fit

Sun Jan 29 11:57:37 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * disable the shape move left arrow when no shapes are there at all

Sat Jan 28 18:53:56 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update NEWS file

Sat Jan 28 18:50:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * simplify a bit

Sat Jan 28 18:46:39 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * also enable echanging of shapes and shape positions in problems

Sat Jan 28 17:19:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use a class that encapsulates the image handling for the image export

Sat Jan 28 17:17:45 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make it possible to reorder problems in the gui, shapes and colors will follow soon

Sat Jan 28 13:14:33 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remvoe abbreviations for problem buttons

Fri Jan 27 19:47:24 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * as the changelog is created from the repository we don't have it IN the repository

Fri Jan 27 19:13:58 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * typo in about box

Fri Jan 27 19:10:35 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix color constraint drawing for windows (the black line around the colors was missing)

Fri Jan 27 18:53:32 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper vertical alignment of text in blocklists and also black color in piece visibility for invisible pieces

Fri Jan 27 18:46:48 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * typo in the rename problem dialog

Fri Jan 27 18:46:00 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * shapes can now have names

Fri Jan 27 17:10:16 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * copyright  updates for 2006

Fri Jan 27 16:59:31 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * tooltips and right box for the scroller in the placement browser window

Fri Jan 27 16:52:14 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * display times (except seconds) with one descimal after the point

Thu Jan 26 19:24:31 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some changelog and news updates

Thu Jan 26 17:50:08 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add lots of tool tips

Thu Jan 26 17:07:18 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't use scientific presentation for number of assemblies and solutions

Thu Jan 26 16:25:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * plug memory leak: found assemblies were not deleted when not disassembable, or only counted

Wed Jan 25 21:38:26 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * make the initiali size for the exit part of the piece tab bigger. Disadvantate: the colors and pieces and not be hidden

Tue Jan 24 17:44:29 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * ask bevore overwriting with saveAs

Tue Jan 24 17:24:32 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fixes for piece number (status line, selection after errors)

Tue Jan 24 17:06:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * save the zoom level for the 3 tabs

Wed Jan 11 18:20:39 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * and one new symmetry found by Derek Bosch

Wed Jan 11 18:12:11 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix bug where the grid editor was only updated after leaving a square

Wed Jan 11 18:06:27 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * shuffling around of the toolbar buttons

Wed Jan 11 17:27:00 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't use named colors in the xpm files, named colors are unknown in windows

Tue Jan 10 14:35:40 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * when adding a new color setup the startup color with something meaningful

Tue Jan 10 14:25:58 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move the color parts to the bottom of the toolbar

Tue Jan 10 14:19:54 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * some shufling around of buttons

Tue Jan 10 11:38:38 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * typo in 3d cursor drawing method

Mon Jan  9 17:15:05 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add new images to makefile

Mon Jan  9 16:22:59 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * more versatile tool functions
  
  now its possible to set variable and fixed cubes on the
  in and on the outside and to also decolorize cubes
  
  all this is done with a more versatile function in the voxel class

Mon Jan  9 11:14:18 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * correct comment

Mon Jan  9 10:29:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * improved the disassembler a bit
  
  the disassembler now no longer finds moves where one piece is moved
  x units and another piece is moved y units in the same direction
  
  the disassembler now finds moved where 2 pieces are moved in the same
  direction, until now it only found these when movement of the first
  piece forced the 2nd to move.
  
  This needs to be improved to larger groups of pieces.

Mon Jan  9 10:10:19 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * typo

Sun Jan  8 16:26:26 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * lokalize the function checkmovement better

Sun Jan  8 16:05:23 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add for now unused antialiasing routine and some more updates to image exporter

Sun Jan  8 10:32:24 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * move 3d-drawer setup routines into the drawer. Now it's possible to use these for the image export

Sat Jan  7 18:06:56 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * lighter background for activated buttons in toolbar

Sat Jan  7 17:40:58 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * fix for grid editor cursor, didn't show up when mirror Z was switched on

Sat Jan  7 16:19:11 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * silence warning the symmetries debug code

Sat Jan  7 16:18:38 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update cursor in 2d view when ouse moves

Sat Jan  7 14:53:36 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * use same idea for 3D cursor as used in grid editor, this removes the speed problem for complex cursors

Sat Jan  7 14:10:30 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * proper grid editor corsor for symmetric drawing modes, remove all warings from module

Thu Jan  5 10:23:45 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * cleanup the z coodinate inversion chaos and start at the bottom row of space when editing

Tue Jan  3 19:10:26 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * implement edit types

Tue Jan  3 19:09:58 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * remove the inner white frame from the box selector

Mon Jan  2 14:03:02 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * don't edit when outside the grid when the mouse is released

Mon Jan  2 13:44:20 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * update 3d-cursor as soon as we are inside the square editor

Mon Jan  2 13:28:44 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * exchange the color and shape parts in the shape tab

Sun Jan  1 18:07:06 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add new images to makefile

Sun Jan  1 18:00:21 CET 2006  Andreas Röver <roever@users.sourceforge.net>
  * add images for transformation buttons and use them

Fri Dec 30 13:45:49 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * changelog update

Fri Dec 30 13:45:01 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add the images to the imagefile so that they are included in distribution

Fri Dec 30 13:22:32 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * first step in redesign of interface

Thu Dec 29 17:10:16 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * edit mode cursor for 3D view

Thu Dec 22 17:21:56 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add line space display for the z axis slider in the grid editor

Thu Dec 22 16:53:35 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * darker green color axis

Thu Dec 22 16:39:35 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix stack drawing

Wed Dec 21 21:51:00 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * have a shadow of the layer below visible on the square drawer, remove color white as the contrast is not high enough

Wed Dec 21 21:32:36 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * mirrored drawing and whole column drawing in swaure editor, unused by now

Wed Dec 21 20:54:03 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * buttons in button groups can now be selected, also end the group right away to avoid manual ending

Wed Dec 21 20:49:56 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * start window size is now 800x600 and the tooltab is wider

Wed Dec 21 20:48:02 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix that removing a color might invalidate the displayed color for the 3d view

Wed Dec 21 20:47:38 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * some docfile updates

Mon Dec 19 21:38:06 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * a new widget: buttonGroup
  
  this widget has a number of buttons of which at each time
  exactly one is pressed (like radiobutton)

Mon Dec 19 21:37:29 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * use a thicker marker for selected blocks

Fri Dec 16 13:07:08 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix scaling problem with edit color button

Fri Dec 16 13:00:54 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * ensure valididy of color selected after removing one. Fix crash when deleting the last color and pressing del right again

Thu Dec 15 18:14:00 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * puzzle is changed, when comment is saved

Thu Dec 15 17:52:29 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix comment loading and enable GUI comment editing

Thu Dec  8 17:31:55 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove the designer field from the puzzle, the comment can contain that information

Thu Dec  8 17:31:30 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove another abbreviation

Thu Dec  8 17:29:05 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove whitespace from lineends

Wed Dec  7 21:42:36 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * check all possible close situations for changed puzzle
  
  up to now you only got a warning, when using quit but not
  when using the window manager "x", or when using Alt-F4, now you do.

Wed Dec  7 21:37:39 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove 2 more abbreviations

Wed Dec  7 21:35:55 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove abbreviations from activities

Wed Dec  7 21:22:13 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * quit not red any longer

Wed Dec  7 20:54:13 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * don't try to disassemble assemblies with only one piece

Wed Dec  7 18:04:32 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * make group edit window resizable

Wed Dec  7 18:02:22 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * make configuration window modal

Tue Nov 29 11:24:02 CET 2005  Andreas Röver <roever@users.sf.net>[_^M_]
  * use parameter from preview window for output

Tue Nov 29 08:13:30 CET 2005  Andreas Röver <roever@users.sf.net>[_^M_]
  * and another symmetry group

Mon Nov 28 19:06:25 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * better tile size

Mon Nov 28 17:50:27 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * use back puffer, as many GL implementations don't provige auxiliary buffers

Mon Nov 28 17:49:45 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * windows requires explicit resize of window for layouted windows

Sun Nov 27 21:34:24 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * start new development cycle

Sun Nov 27 21:30:50 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * some more image exporting functionality

Sat Nov 26 15:33:52 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * separate the voxel drawing from the gui part
  
  Now it can be reused for the image export. But this is only a first step
  as there seem to be some strange bug resulting in event getting queuesd
  up and the F3 key not always getting through

Sat Nov 26 12:27:04 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * unix style line breaks

Sat Nov 26 12:26:38 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * wider buttons

Sat Nov 26 12:25:56 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * a few more options for export window

Sat Nov 26 12:24:31 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add libpng
  
  this library will be used to output the rendered images into
  png files

Sat Nov 26 12:07:29 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add the tile rendering library
  
  This library will be used to render the large size pictures
  for the image export

Fri Nov 25 22:15:24 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * start work on Image Export Functionality
  
  Right now only a simple dialog with some of the possible options
  is shown and a new meny entry for testing purposes

Fri Nov 25 22:14:52 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * disabiguate layouter function prototype

Fri Nov 25 21:17:25 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add a few GPL header to files

Fri Nov 25 21:10:41 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add first version of the layouter
  
  with this layouter its (hopefully) possible to quickly design
  even complex dialogs by leaving the concrete layout to the
  computer and only defining the relative playement of the different
  groups inside the window

Fri Nov 25 17:03:50 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.8b

Thu Nov 24 18:25:31 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * release preparations

Tue Nov 22 19:23:29 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * replace literal with correct define and solve a Bug found by Markus

Tue Nov 22 19:06:33 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * missed an insance with the counters

Sun Nov 20 17:09:10 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * start counting pieces and multipieces from one and not from 0

Mon Nov 14 19:42:30 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * use brackets insted of "=" for level moves

Mon Nov 14 19:37:16 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * clean status bar when switching to solve tab

Mon Nov 14 19:32:19 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * unify and nicify tooltips

Mon Nov 14 19:17:31 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix scrollbar Problem in solve tab

Mon Nov 14 19:14:59 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * correct spelling of Bill Cutler

Sun Nov 13 15:47:17 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove FIXME comment, this is fixed

Sun Nov 13 15:41:42 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * get rid of global variable ui
  
  the global variable has been a real design problem. Now without it
  we will be able to open several windows and copy information from one
  to the next and so on

Sun Nov 13 11:57:39 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add a chapter for future design possibilities

Fri Nov 11 22:40:54 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.8a

Fri Nov 11 22:40:26 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * update to 0.1.8a

Fri Nov 11 22:35:53 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix problem with assert window
  
  the source of the problem has been that when the assembly
  process asserted while already running it was not correclty
  reset which lead to an endless loop while waiting for the
  thread to finish
  
  now the thread is reset, also the interfice is updated

Fri Nov 11 22:33:59 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * more whitespace

Fri Nov 11 18:25:35 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some whitespace

Fri Nov 11 17:27:49 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * oops typo

Wed Nov  9 21:28:04 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * put something into the README file

Sat Nov  5 18:17:00 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.8

Sat Nov  5 16:18:10 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * news and changelog updates

Sat Nov  5 16:16:53 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * minimize pieces for now, before starting to solve

Sat Nov  5 16:16:35 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add the example into the distribution file

Sun Oct 30 23:14:50 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * and 2 more

Sun Oct 30 22:38:11 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * 2 more groups and bugfix in debugging code for symmetry checking

Sun Oct 30 16:27:59 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * another example the designer kinly allowed me to bundle the file

Sun Oct 30 15:03:10 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * yet another symmetry group

Sun Oct 30 14:57:31 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * no newline option for burrTxt

Sun Oct 30 14:15:10 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * quiet option for burrTxt

Sun Oct 30 12:50:27 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * update comment

Sun Oct 30 12:50:15 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfix

Wed Oct 26 21:52:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * documentation update

Wed Oct 26 21:31:31 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * changelog and NEWS file update

Wed Oct 26 21:31:03 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add some examples

Tue Oct 25 18:56:02 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * tab removal

Tue Oct 25 18:14:34 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * now we can also set the color only

Tue Oct 25 17:05:19 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * cleanup of grid editor
  
  now there is a button in the tool side bar that allows you to
  select what you want to do. Also the "Edit all Layers" button
  has been moved there.
  
  Also lots of cleanup in the square editor resulting from this

Tue Oct 25 16:58:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * redraw after toggeling

Tue Oct 25 16:57:57 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use shortcut keys in the menu instead manual ones

Tue Oct 25 16:50:21 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * windows versions don't have __STRING

Mon Oct 24 19:52:55 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use the character code for + and - instead of the key

Mon Oct 24 16:47:42 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * increase puzzle version and make corrections after loading old version file

Mon Oct 24 16:46:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * display a message when the placement browser is opened in intermediate assembling state

Mon Oct 24 16:43:34 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * spell my name right

Sun Oct 23 19:57:16 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * OSX specific parameter handling
  
  OSX passes a process id as the first parameter so we can not load
  that file and we skip opening files
  
  we should have a proper solution there and do something more appropriate

Sun Oct 23 19:32:41 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * gcc 4.0 fixes

Sun Oct 23 17:36:31 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * news and changelog updates

Sun Oct 23 16:46:20 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * documentation update (placement browser and group editor explained)

Sun Oct 23 14:12:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * no newlines for log lines

Sun Oct 23 14:03:19 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * another symmetry group

Sun Oct 23 10:04:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some debug code

Sat Oct 22 21:30:22 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some unused code

Sat Oct 22 21:29:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * die tab die

Sat Oct 22 21:20:28 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * new asserts that throw an exception instead
  
  this new scheme allows to catch after the lib produces
  an unsolvabale error. A window with some information is
  displayed and the program doesn't crash
  
  Sadly FLTK is by default compiled without exception support
  (what a crap) so the exceptions don't go through the callbacks
  and so the program still crashed on asserts in the GUI
  instead of saving the puzzle and shutting down

Sat Oct 22 10:09:02 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * include all documentation files in distribution

Fri Oct 21 17:15:22 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * make lines a bit thicker (for coordinate system and layer highlighting)

Fri Oct 21 17:14:04 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * improvements to groups editor
  
  - simplified code
  - only set change flag, if the user really does change something

Fri Oct 21 17:01:40 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * improvements for keyboard shortcuts
  
  - F2 now saves, F3 loads, F4 toggled 3D view
  - only toggle and +- layer when in shape tab

Fri Oct 21 16:56:40 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * improvements to placement browser
  
  - don't crash when 0 placements are there
  - speed improvement (only the delta is stepped through the matrix
    instead if starting fresh of each change
  - correctly handle empty result shape

Fri Oct 21 16:49:44 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add another symmetry group, sigh

Thu Oct 20 18:34:03 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * show the currently worked on piece when reducing

Thu Oct 20 18:22:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * hotspot at origin is no longer necessary

Thu Oct 20 18:22:15 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * placement browser activation only possible when assembler is available

Thu Oct 20 18:05:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * save the hotspot, if it is not zero (we might need that some time in the future)

Thu Oct 20 17:51:47 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * the upper limit of the bounding box was not moved when the voxel space content was moved

Thu Oct 20 17:51:18 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * check that the hotspot is really in the origin when starting to solve a puzzle

Tue Oct 18 18:27:31 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * take the bounding box of pieces into consideration

Tue Oct 18 18:04:20 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * each transformation of a piece results in resetting the hotspot to 0 and removing solutions

Tue Oct 18 17:31:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * die tab, die

Mon Oct 17 22:03:18 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use vectors for nodes and thus get rid of node counting

Mon Oct 17 22:02:57 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * + and - only work in shape view

Mon Oct 17 22:02:37 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * new and changelog updates

Mon Oct 17 21:54:40 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * new symmetry avoiding system

Sat Oct  8 19:52:53 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * subproblem creation and recursion moved into function

Sat Oct  8 18:38:03 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * the comefreom field of nodes in the disassembler are instatiated in the constructor

Sat Oct  8 14:51:09 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add hotspot functionality
  
  a Hotspot is a point inside a voxel space that always stays at the
  same position reltvie to the shape defined inside the voxel space,
  so if you have the hotspot at some special corner and now flip rotate
  and shift the piece around inside the voxelspace the hotspot will stay
  at the same corner of the piece and move along with this corner
  
  What is that useful for?
  
  To rotate assemblies. because now it is possible to recalculate the
  orientation of a piece and calculate the new position of the hotspot
  independent of the concrete shape of the piece

Mon Oct  3 13:52:12 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * assembly rotation first fixes, more needs to be done

Sun Oct  2 11:33:54 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some more updates to algorithms

Thu Sep 29 17:50:27 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add function to movementcache to remove information concerning one shape

Wed Sep 28 21:29:27 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * describe some internals

Tue Sep 27 20:39:50 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * tons of typos

Mon Sep 26 17:34:23 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some typos in news file

Sun Sep 25 18:50:00 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update Documentation partly with Doc Sonnevelds suggestions

Thu Sep 22 21:44:14 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * merge pieceVoxel and voxel
  
  pieceVoxel_c is no longer required as we don't have the assembly
  voxel any longer whose existence has been the reason for
  a base voxel class and 2 specialized classes with different
  information per voxel

Thu Sep 22 21:17:09 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * first step to the new rotation avioding method

Tue Sep 13 18:06:09 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some comments and a bugfix for symmetry avoidance

Sat Sep 10 14:24:16 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add placement browser
  
  this is a window that lets you go through all the placements
  that each piece of the puzzle can have. This is mainly for
  debugging reasons, if you want to find out why a certain solution
  doesn't exist

Wed Sep  7 17:19:07 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * documentation updates

Tue Sep  6 21:47:41 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * Apple has the OpenGL files in another directory. Also remove an unnecessary include

Tue Sep  6 20:26:38 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some more changelog updates

Tue Sep  6 20:25:30 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * hide marker whenever not needed

Tue Sep  6 20:17:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix some widget exchange issues

Tue Sep  6 19:44:39 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * toggle + and - key shortcut and also have the limits checked

Tue Sep  6 19:40:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use a box instead of an output widget for the status line text or it will get the focus and collect keystrokes

Tue Sep  6 19:39:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * plus and minus change the layer to edit

Tue Sep  6 19:37:44 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correct event handling functions
  
  we really do need to return 0 when we do not handle the
  event or else key shorcuts will not arrive

Sat Sep  3 11:34:49 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove assemblyVoxel_c class
  
  we don't really need this class any longer. Assenblies are
  saved in the assembly_c class that saves the position of
  the pieces. This class was only kept because I've been too
  laze to rewrite the print routines thats done now

Thu Sep  1 18:25:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use the home directory (profile) on windows, too

Thu Sep  1 18:21:25 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update documentation

Wed Aug 31 21:53:15 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * sort menu into submenu(es) and add first keyboard shortcut

Wed Aug 31 21:32:03 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * whitespace

Wed Aug 31 21:31:48 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove a long standing warning

Wed Aug 31 21:31:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * care for user changing the count in the group window

Wed Aug 31 21:21:31 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * the groups edit window doesn't nee to be global

Wed Aug 31 21:15:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix for wrong handling of grouping class + optimisation
  
  we can sadly not assert that the user will not call the
  grouping class after it has returned false, so make sure that
  we do noting but return false once that happened
  
  als we don't need to evaluate the 2nd part of the puzzle once
  the first part turned out to be not disassembable

Wed Aug 31 20:41:46 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * only add a group record when the group is not 0

Wed Aug 31 19:41:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * updates of project files

Wed Aug 31 19:37:25 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix problem with "vanishing" bottom widget in shape editor, problem now: the middle separator may jump

Wed Aug 31 17:34:08 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * improvements for configuration dialog

Wed Aug 31 17:22:39 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * save windows position in config file

Tue Aug 30 22:05:04 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * get rid of 2 unused variables

Tue Aug 30 22:00:57 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add configuration support
  
  for the moment a simple configuration, just 2 switches
  tooltips and the lightning in 3D mode. The configuration
  class also lacks the other data types except for bool, also
  the dialog needs some brush up, but it works for now...

Mon Aug 29 18:40:19 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * new constructor for buttons (with pointer)

Mon Aug 29 18:39:43 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * cleanup for grid editor event handling

Mon Aug 29 18:39:15 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update about box to contain used libs and modules

Mon Aug 29 18:36:22 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add GUI to edit groups properly

Sun Aug 28 12:30:30 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * make UserInterface into a derived window class and not a container for the window

Sun Aug 28 12:20:57 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove using namespace from include file

Sun Aug 28 11:58:49 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * updates to NEWS file

Sun Aug 28 11:50:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * the string for the text block list is 200 characters long

Sun Aug 28 11:48:29 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add better grouping of pieces for disassembler
  
  now each (set of) piece(s) can belong to several groups and
  the disassembler will assign groups as it progresses with
  its task. As soon as it hits a not disassembable set of
  pieces it looks if they can be assigned groups so that they
  are all in the same group

Wed Aug 24 16:48:22 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update to 3D-View Grid-View exchange, more stable

Tue Aug 23 16:16:05 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * first try at a possibility to toggle the grid and 3D view in the shape tab so that the grid has more space

Tue Aug 23 16:07:07 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * minimize on empty voxel spaces caused a crash

Tue Aug 23 16:05:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * turn the slider with the square editor around so that is behaves more intuitive

Mon Aug 22 21:24:14 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * now we also don't need to draw the faces joining to variable cubes

Sun Aug 21 21:48:28 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bigger steps for solution animations

Sun Aug 21 21:31:08 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * reformat cursor code

Sun Aug 21 21:30:21 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * variable cubes are no longer with smaller cube but with a cube with a black square on each face

Sun Aug 21 15:18:47 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add some kind of cursor to the 3D view

Sat Aug 20 21:49:09 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * show both the sum of moves and all the levels of the puzzle above the moves slider

Sat Aug 20 21:11:09 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * sort found solutions by disassembly complexity

Sat Aug 20 20:57:25 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * the solution selector now takes the focus, so you can use the keys to select solutions

Sat Aug 20 20:49:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * When you dragged the tab so that the 3D view was 0 width the program crashed, fixed now

Sat Aug 20 20:43:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * wrong assert causing abborts when colors were deleted

Sat Aug 20 20:43:35 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some debug prints left over

Fri Aug 19 16:55:04 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.7

Fri Aug 19 16:54:06 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * last release preparations

Fri Aug 19 16:51:17 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * more marker functions from the header into the c-file

Fri Aug 19 16:38:19 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix bug that made the program not save the result shape
  
  the number of shapes in the problem has nothing to do with
  the number of shapes in the puzzle

Fri Aug 19 16:37:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some more updates to reduce and also a version update for assembler because of reduce

Thu Aug 18 21:48:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * more preparations for 0.1.7

Thu Aug 18 21:37:01 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * enable reducer but in a very simple form

Thu Aug 18 17:19:01 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * split of the 2nd part of bills algorithm and optimize it further

Thu Aug 18 16:54:34 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * rename node4_c to node0_c as the disassembler has been renamed, too

Thu Aug 18 16:48:37 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add maximum pieces parameter to checkmovement function
  
  this parameter will com in handy once I update the movement
  search function to first try to do simple moves and then
  more complex ones

Thu Aug 18 16:42:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove the inverse array again, its not needed

Thu Aug 18 16:36:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * comment the movement cache class

Thu Aug 18 16:36:09 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some comment updates and cleanup

Thu Aug 18 16:32:40 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * optimize the 2nd part of bills algorithm
  
  as the again value only counts for each direction we do now
  each direction alone one after another and not together

Thu Aug 18 16:32:07 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some unused functions from disassembly node

Thu Aug 18 16:30:06 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * handle more than one piece at the leafs of the disassm trees
  
  with the new group feature the ends of the disassm trees can
  now contain more than one piece, so we need to use a loop
  at the tree end and place all the pieces

Thu Aug 18 16:28:06 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove unused variable assembly from object disaasmtomoves
  
  this variable is not needed any longer because the positions of the
  pieces are absolute

Wed Aug 17 22:06:35 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * rename disassembler_4 to disassembler_0

Wed Aug 17 21:55:48 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove all the old disassemblers

Wed Aug 17 21:46:17 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * improve disassembler_4 so that it now uses a global movement calculation cache
  
  spee should now be on par with puzzlesolver3d even for easy living

Sun Aug 14 12:17:19 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * create a placement class that represents the position of a piece

Sun Aug 14 09:52:21 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * redesign disassembler interface so that we can reuse the same object multiple times
  
  this makes is possible to use the movement cache more than once by
  just keeping the object and the appended movement cache. This will
  make is possible (once the movement cache can cope with transformations
  to reuse the cache from older assemblies

Sat Aug 13 19:38:39 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * document the new edit modes and piece groups

Sat Aug 13 16:06:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * improve editing possibilities
  
  editing now always fills rectangles instead of single cubes
  a new button alows to toggle between editing all layers and
  only the current one

Sat Aug 13 14:14:10 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * avoid segfault on quit

Sat Aug 13 14:05:49 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * don't make inside holy for inported puzzles

Sat Aug 13 14:04:38 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfix for pressing cancel in inport window

Thu Aug 11 21:51:27 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * preparation for release 0.1.7

Thu Aug 11 21:45:01 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove warnings (signed unsigned comparisons)

Thu Aug 11 21:17:53 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * include an inverse transformation array and replace the number of transformations with a constant

Thu Aug 11 19:26:17 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add transformation to the node. This might enable us later on to rotate pieces

Thu Aug 11 18:24:23 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add an import function for puzzle solver files

Tue Aug  9 18:11:08 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * move the node definition into the disassembler files so that each disassembler can have its own
  
  this starts to get necessary because we will need to have a different
  node for the 4th disassembler because it may get rotations included
  and so it needs a 4th field specifying the rotation

Tue Aug  9 17:20:22 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix for voxel drawing besides variable voxels

Mon Aug  8 21:48:23 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * problems may not yet have a result when they are saved

Mon Aug  8 21:03:30 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * burr grower can select the problem to work with

Mon Aug  8 20:58:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * implement piece groups
  
  This allows you to put piece into groups that don't need to be
  taken apart to solve the disassembly of the puzzle. This is required
  for example for puzzles like "cube in cage" where the cage consists
  of 3 movable pieces that can not be taken apart.
  
  The gui currently alows you to increase the group number.
  
  Group number 0 is special, it means that the piece doesn't belong to
  any group at all and must be single in the disassembled puzzle

Fri Aug  5 12:30:18 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add a function to calculate the inverse transformation

Thu Aug  4 09:47:25 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * get the burr Grower working again

Thu Aug  4 09:46:53 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * problems are NOT editable, when solved

Thu Aug  4 09:46:36 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add paragraph about the errors in the text

Wed Jul 13 20:08:49 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.6

Wed Jul 13 20:07:57 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * release 0.1.6 preparations

Wed Jul 13 20:06:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * for wrong time display problem
  
  sometime the displayed time war way to big this was probably because
  the time was asked bevore the thread could initialize it, so
  do this bevore the thread started

Wed Jul 13 19:57:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add pictures for documentation

Wed Jul 13 19:54:18 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update solution display after pressing start

Wed Jul 13 19:41:50 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * cleanup and lots of comments

Wed Jul 13 19:41:00 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix for problem selecting solution tab with empty gui

Wed Jul 13 19:35:33 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfix and better time output

Tue Jul 12 19:37:37 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * documentation update

Tue Jul 12 18:30:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some more asserts removed from load code, also some more consistency checks

Tue Jul 12 17:29:29 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use exceptions for load errors instead of asserts. Now the user gets an error message when loading fails

Tue Jul 12 16:41:02 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * error message when the thread could not be started

Tue Jul 12 16:31:17 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix for win 9x. They do require a handle pointer for the thread creation

Mon Jul 11 22:10:05 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * enable the time estimation, add some asserts and initialize some values that should always have been

Mon Jul 11 21:10:55 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove the interations display

Mon Jul 11 21:07:06 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * enable "just count" switch

Mon Jul 11 16:59:42 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * we can not display problem info, when the given problem is not valid

Mon Jul 11 16:58:42 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * we now need to update when the tab is toggled, as we only update the visible widgets

Mon Jul 11 16:58:27 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * documentation updates

Sun Jul 10 19:33:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add button to change a color

Sun Jul 10 18:41:34 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.5

Sun Jul 10 18:41:10 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * relese 0.1.5 preparations

Sun Jul 10 18:40:02 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some gcc 4 fixes

Sun Jul 10 18:30:04 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * sort widged updating by tab and only update the pieces that are in the current tab

Sun Jul 10 17:59:32 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * only redraw the tab, because only widgets in the tab are updated

Sun Jul 10 17:56:53 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * merge updateSolutionStats and updateInterface

Sun Jul 10 17:53:30 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * oops, this is the right way to check the piece shapes for variable voxels

Sun Jul 10 07:48:14 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * stop pressing while in preparation caused segfault because the assembler was not yet set in the puzzle struct

Sun Jul 10 07:47:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * check for variable cubes in pieces and error out, also errors that mention one piece jump to that piece

Sat Jul  9 14:03:10 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some more status line updates

Sat Jul  9 14:02:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * uninitialised pointer

Sat Jul  9 09:27:39 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update interface when pressing new puzzle

Fri Jul  8 21:47:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * plug some memory leaks

Fri Jul  8 20:29:16 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * the thread has also stopped on error and not only in pause and finished state

Fri Jul  8 20:29:03 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * valgrind fixes

Fri Jul  8 20:28:49 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * whitespace

Fri Jul  8 20:28:18 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove solutions when editing the puzzle

Fri Jul  8 20:27:41 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some cruft

Thu Jul  7 21:26:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * disable all dangerous editing while solving is in progress

Thu Jul  7 17:18:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * whitespace

Thu Jul  7 17:17:16 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add a attribute to the assembler state to make incompatible changes possible, show error message when restoring failed

Thu Jul  7 17:08:43 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * disable voxel edit tools, when there is nothing to edit

Wed Jul  6 21:04:06 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.4

Wed Jul  6 18:27:25 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * move assembky callback functions into library

Wed Jul  6 18:04:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * changelog and NEWS update

Wed Jul  6 18:02:56 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * populate the status line with some information

Wed Jul  6 17:31:25 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * dont active solution when not in solve tab

Wed Jul  6 17:24:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some debug prints

Wed Jul  6 17:05:30 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * version 0.1.4 update

Wed Jul  6 17:04:45 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * a bit more agressive reduce, let's just hope that this is not too much

Wed Jul  6 17:04:31 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * valgrind fix

Wed Jul  6 17:03:45 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfixes for the assembly state saving

Tue Jul  5 20:38:13 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * valgrind uninitialised memory warnings

Tue Jul  5 17:57:56 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * implement saving of the current solving state

Mon Jul  4 21:41:32 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add tooltip for color toggle in the status line

Mon Jul  4 20:41:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * don't try as hard to reduce, remove the switch again from GUI

Mon Jul  4 20:26:44 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * reintroduce all disassemblers and have a switch in burrTxt to select

Mon Jul  4 20:10:36 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use the new disassembler in the GUI

Sun Jul  3 12:49:17 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix memory leaks and inconsisten new [] delete [] calls

Sun Jul  3 12:47:19 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add a new disassembler
  
  this diassembler uses a cache to store the movement possibilities for
  each piece pair and relative position of this pair. The cache is then
  later on used to faster fill the matrix.
  
  This algorithm could be improved by keeping the cache over the period
  of solving one puzzle. This is escpecially useful when the puzzle has
  many assemblies (like Easy living)
  
  This algorithm speeds up complex puzzles like Pelikan Burr quite a bit
  (only 50% time left) but slows down puzzles with many simple assemblies
  as the cache has to be rebuild each time.
  

Sat Jul  2 20:47:25 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * the rotation function can not rotate by 90, 180 and 270 degree in one step

Sat Jul  2 20:47:03 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfix

Sat Jul  2 20:45:47 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use the bounding boxes of the voxel space to calculate the bounds for the disassembler

Sat Jul  2 20:09:48 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove the depth fields from the disassembler they didn't bring enough for the complexity

Sat Jul  2 20:05:54 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * voxel space creation speedup (huge speedup)

Sat Jul  2 17:09:44 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * missed the gzstream files, they should have been ther for a long time already

Wed Jun 29 06:38:48 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove the visual c files as they don't work anyway and mingw workd out of the box

Tue Jun 28 19:47:12 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correctly bail out on error

Tue Jun 28 16:31:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add the missing lines at the edges, don't draw edges at color contrains changes

Mon Jun 27 21:40:34 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add new status bar at the bottom of window and connect everything

Mon Jun 27 21:39:22 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add widget for status line

Mon Jun 27 21:38:15 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * enable coloration of cubes by constraint color

Mon Jun 27 17:07:46 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correction for separator text size calculation

Mon Jun 27 17:07:29 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add web adress to about dialog

Mon Jun 27 17:07:01 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correct colorConstraint drawing under windows

Sun Jun 26 21:53:22 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.3

Sun Jun 26 21:52:55 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use thing up boxes for buttons

Sat Jun 25 12:27:47 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update documentation

Sat Jun 25 12:27:15 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update changelog

Sat Jun 25 11:19:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * reenable the reduce switch
  
  ... for now. I really do need to find a reduce function that
  is always fast...

Sat Jun 25 11:02:28 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * enable the stopping while in preparation
  
  you can now press the stop button, while the asdsembler is preparing
  it will finish the preparation and then return to the user

Sat Jun 25 10:44:48 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correct bounding box comparison

Sat Jun 25 10:35:18 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use bounding box for piece fitting test -> speedup

Sat Jun 25 10:34:48 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * don't activate solutions on color selection

Sat Jun 25 10:00:11 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add xml flags to library compilation

Sat Jun 25 09:55:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * select shape on piece click
  
  the right shape get's now selected when you click at one of
  the pieces in the piece+counter view at the bottom of the problem
  tab. This improves usability quite a bit

Fri Jun 24 21:34:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add about box

Fri Jun 24 21:28:07 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * simplify message call

Fri Jun 24 21:14:12 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * new version

Fri Jun 24 21:12:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * line whitespace

Fri Jun 24 21:10:06 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * problem renaming and activation of the new created problems after the creation

Fri Jun 24 20:50:13 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * interface update function

Thu Jun 23 21:35:04 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * get not fitting error messages working

Thu Jun 23 21:19:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * set z layer to 0 on new shape

Thu Jun 23 21:11:29 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * new comparison function used to compare voxel space contents within bounding box
  
  this new functionality is used when comparing rotations as the old
  function wouldn't work with not minimized voxel spaces

Thu Jun 23 19:31:11 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * better error interface in the library, use this interface. Burrgui now has message boxes on errors

Thu Jun 23 17:10:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * save as compresses now too, also check for extension

Wed Jun 22 18:08:14 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * deleting the last piece resulted in endless loop

Wed Jun 22 17:56:43 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update, when shapes are deleted

Wed Jun 22 17:14:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * get rid of the signed <-> unsigned comparisons

Wed Jun 22 17:05:21 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * when the size was very small the subtraction would overflow and result in a large grid

Tue Jun 21 20:58:31 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.2

Tue Jun 21 20:20:58 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * corrections for mingw

Tue Jun 21 20:11:42 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * show the selected shape in the upper right corner

Tue Jun 21 19:53:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add white as color

Tue Jun 21 19:53:27 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update 3d-view on edit

Tue Jun 21 19:45:05 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfixes: crash when number of pieces was changed, update screen when shape delete

Tue Jun 21 18:51:20 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * consistency between slider and block list
  
  the problem is that the size of the block list is only known
  after is was drawn, so we need to draw the slider after
  the block list has been drawn and the slider had been updated

Tue Jun 21 18:01:05 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfix for arcball. When nothing was shown at the start and you dragged the mouse the transformation got screwed up resulting in nothing shown

Tue Jun 21 17:14:59 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * wireframe improvements and fade out now includes the black edges

Mon Jun 20 21:56:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * next release

Mon Jun 20 21:55:44 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix blocksize for piece visibility

Mon Jun 20 21:52:21 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * check for valid values when setting up the 3d views

Mon Jun 20 21:51:23 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * more const correctness

Mon Jun 20 21:18:39 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * fix asserts on "new"

Mon Jun 20 16:46:13 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * don't skip when using the zoom slider for the first time

Mon Jun 20 16:43:55 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * windows rectangles set the draw color

Sun Jun 19 21:43:46 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.1

Sun Jun 19 21:43:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * next release

Sun Jun 19 21:02:08 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * a small optimisation, don't need to do anything, when piece is transparent

Sun Jun 19 20:45:08 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * squash warning

Sun Jun 19 20:44:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * activate piece on load so that there is no empty piece on load of a file

Sun Jun 19 20:38:53 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add header, where missing

Sun Jun 19 20:35:24 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * cleanup in arcball files (mainly linebreaks)

Sun Jun 19 20:33:23 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use exceptions instead of asserts for loading

Sun Jun 19 19:36:00 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * enable visibility toggling

Sun Jun 19 17:31:57 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correct centering of result and cooredinate system for piece view

Sun Jun 19 17:25:08 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * update to the voxel view class
  
  the new voxel view class uses multiple voxel spaces
  to view the complete result instead of one, this will
  be more flexible for the future: (color constraints
  in results)
  I also use the new functionality with the problem viewer
  right now

Sun Jun 19 17:24:30 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * some small updates (const correctnes and a helper function)

Sun Jun 19 08:41:12 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * misc fixes
  
  - remove debug output in lib
  - reinstanciate display update timer when solving, without it the
    GUI uses up too much CPU time
  - fix some crashes and problems

Sat Jun 18 19:22:19 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * avoid bounding box recalculation

Sat Jun 18 19:20:02 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * don't make a copy of the puzzle, this is not needed any longer
  
  this was necessary because the old functions required minimzed
  pices, now this is not necessary any longer

Sat Jun 18 19:19:06 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use gzipped output file

Sat Jun 18 15:03:10 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * optimize the update of the bounding box when transforming (rot and mirror)

Sat Jun 18 14:13:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use the bounding box for the preparation

Sat Jun 18 14:02:01 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * add an internal bounding box to the voxel space

Sat Jun 18 13:15:36 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * use assembly in puzzle solutions instead of the assembly voxel space
  
  this saves a bit of space in the xml files, the usage of the assembly
  will also further go down into the different tasks then now, e.g
  the voxel space shoule really use the assembly instead of the current
  assemblyVoxel space.

Sat Jun 18 12:08:49 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * const correctnes

Sat Jun 18 11:24:23 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some warnings

Sat Jun 18 09:53:11 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * format changes

Sat Jun 18 09:42:52 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correctly use the new assebly class

Mon May  9 21:59:33 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * better boxes :-)

Mon May  9 21:59:10 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * typo

Mon Mar 28 20:08:05 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfixes

Mon Mar 28 16:33:09 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * improvements for printing

Mon Mar 28 16:32:32 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * correctly load in burrText

Mon Mar 28 16:08:50 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * const correctnes

Mon Mar 28 16:08:26 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * bugfixes in assermby_c class

Mon Mar 28 16:06:53 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * readd printing function in an extra external module

Mon Mar 28 14:24:49 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove some more warnings

Mon Mar 28 14:22:51 CEST 2005  Andreas Röver <roever@users.sourceforge.net>
  * step 2 of applying assembly result changes

Thu Mar 24 22:24:12 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add assembly class to contain assembled puzzle

Sun Mar 20 21:15:25 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * better commenting, some cleanup

Sun Mar 20 18:37:16 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * more warnings removed, move position fields out of main window in DisassmToMoves class

Wed Mar  9 21:50:17 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * remove Warnings part 1

Wed Mar  9 21:29:28 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * introduce new interface for voxel viewer

Mon Mar  7 21:05:30 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  tagged 0.1.0

Mon Mar  7 21:04:35 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * correction for error throwing so that is loads again

Sun Mar  6 21:51:27 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * redesign part III

Tue Mar  1 21:44:59 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * Mayor reordering Part II
  Next part of the reordering, still not much working but
  we are getting there. The programm now can again solve puzzles
  and show the solutions
  

Mon Feb 28 21:19:51 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * Major Restructuring
  This patch does three major things:
  - restucture the puzzle oranisation into using problems with
    each problem using shapes from a puzzle wide defined list
  - use XML to save the puzzles
  - allow for color constraints

Sat Jan  1 20:56:47 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * don't crash when mous goes below edit area in square editor

Sat Jan  1 20:46:19 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * allow multiple result shapes part II (small fix)

Sat Jan  1 20:45:02 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add saving to XML

Sat Jan  1 16:57:04 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add color constraints to library (still unused in gui and not saved)

Sat Jan  1 16:11:04 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * allow for multiple result shapes

Sat Jan  1 15:55:16 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * some cleanup

Sat Jan  1 13:13:36 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * specialize the voxel class
  
  the voxel class now has 2 subclasses one for each of the uses
  
  the assemlbyVoxel class is for assembled puzzles with a special
  value for empty voxels and the right numbers for the pieces
  
  the pieceVoxel contains the state and NEW also a field called color
  that will be used to constrain piece placement

Sat Jan  1 12:39:23 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * add frontend for cube puzzles

Sat Jan  1 11:36:33 CET 2005  Andreas Röver <roever@users.sourceforge.net>
  * const correctness

Fri Dec 31 10:09:54 CET 2004  Andreas Röver <roever@users.sourceforge.net>
  * update copyright header

Sat Dec  4 21:30:28 CET 2004  Andreas Röver <roever@users.sourceforge.net>
  * Some documentation restructuring and additions

Sat Dec  4 16:49:40 CET 2004  Andreas Röver <roever@users.sourceforge.net>
  * misc formatting

Sat Dec  4 16:48:38 CET 2004  Andreas Röver <roever@users.sourceforge.net>
  * Factor out file loading

